-- =============================================================================
--  CLEARFONT BY KIRKBURN  v11000-4  12.04.06
--  Official website:  http://seis.bris.ac.uk/~gp3509/ClearFont/
-- =============================================================================
--  CLEARFONT.LUA - STANDARD WOW UI FONTS
-- =============================================================================





-- =============================================================================
--  A. CLEARFONT FRAME & FONT LOCALS FOR BREVITY LATER
-- =============================================================================
--  Add your own font local, following the example (the last line)
--  Keep this section the same in both lua files for consistency
-- =============================================================================

ClearFont = CreateFrame("Frame", "ClearFont");

local CLEAR_FONT_BASE = "Interface\\AddOns\\Insomniax_Core\\Fonts\\";				--"Interface\\AddOns\\!ClearFont\\Fonts\\";	--  ***LedMirage 4/21/2006
local CLEAR_FONT = CLEAR_FONT_BASE .. "IX_Font_Bold.ttf";							--"ClearFont.ttf";						--  ***LedMirage 4/21/2006
local CLEAR_FONT_BOLD = CLEAR_FONT_BASE .. "Montreal_Bold.ttf";						--"ClearFontBold.ttf";					--  ***LedMirage 4/21/2006
local CLEAR_FONT_ITALIC = CLEAR_FONT_BASE .. "IX_Font_Bold_Italic.ttf";				--"ClearFontItalic.ttf";					--  ***LedMirage 4/21/2006
local CLEAR_FONT_BOLDITALIC = CLEAR_FONT_BASE .. "IX_Font_Bold_Italic.ttf";			--"ClearFontBoldItalic.ttf";				--  ***LedMirage 4/21/2006
local CLEAR_FONT_NUMBER = CLEAR_FONT_BASE .. "IX_Font_Bold_Italic.ttf";				--"ClearFont.ttf";						--  ***LedMirage 4/21/2006
local YOUR_FONT_STYLE = CLEAR_FONT_BASE .. "IX_Font_Condensed_Bold.ttf";											--  ***LedMirage 4/21/2006





-- =============================================================================
--  B. STANDARD WOW UI SECTION
-- =============================================================================
--  This is the most important section to edit!
--  Main font styles are listed first, the rest follows alphabetically
-- =============================================================================
--  For the example GameFontNormal:SetFont(CLEAR_FONT, 13);
--  The first part in the brackets is the font style, followed by the font size
--  Change to suit your needs!
-- =============================================================================

function ClearFont:ApplySystemFonts()


-- In-World, '3D' Fonts, etc. (Dark Imakuni)
--------------------------------------------

-- Chat bubbles
   STANDARD_TEXT_FONT = CLEAR_FONT;

-- Names above people's heads
   UNIT_NAME_FONT = CLEAR_FONT_BOLD;				-- CLEAR_FONT;						--  ***LedMirage 4/21/2006
   NAMEPLATE_FONT = CLEAR_FONT_BOLD;				-- CLEAR_FONT;						--  ***LedMirage 4/21/2006

-- The damage pop-up over your target's head (*not* SCT/SDT related)
   DAMAGE_TEXT_FONT = CLEAR_FONT_NUMBER;

-- Drop-down menu font size
   UIDROPDOWNMENU_DEFAULT_TEXT_HEIGHT = 12;


-- System Font
--------------

   SystemFont:SetFont(CLEAR_FONT, 17);


-- Primary Game Fonts: the main font you see everywhere
-------------------------------------------------------

   GameFontNormal:SetFont(CLEAR_FONT, 13);
   GameFontHighlight:SetFont(CLEAR_FONT, 13);

   GameFontDisable:SetFont(CLEAR_FONT, 13);
   GameFontDisable:SetTextColor(0.6, 0.6, 0.6);

   GameFontGreen:SetFont(CLEAR_FONT, 13);
   GameFontRed:SetFont(CLEAR_FONT, 13);
   GameFontWhite:SetFont(CLEAR_FONT, 13);
   GameFontBlack:SetFont(CLEAR_FONT, 13);


-- Small Game Fonts: also used in Titan Panel
---------------------------------------------

   GameFontNormalSmall:SetFont(CLEAR_FONT_BOLD, 10); 				--  12		--  ***LedMirage 4/21/2006

   GameFontDisableSmall:SetFont(CLEAR_FONT_BOLD, 10);				--  12		--  ***LedMirage 4/21/2006
   GameFontDisableSmall:SetTextColor(0.6, 0.6, 0.6);

   GameFontDarkGraySmall:SetFont(CLEAR_FONT_BOLD, 10);				--  12		--  ***LedMirage 4/21/2006
   GameFontDarkGraySmall:SetTextColor(0.4, 0.4, 0.4);

   GameFontGreenSmall:SetFont(CLEAR_FONT_BOLD, 10);					--  12		--  ***LedMirage 4/21/2006
   GameFontRedSmall:SetFont(CLEAR_FONT_BOLD, 10);					--  12		--  ***LedMirage 4/21/2006
   GameFontHighlightSmall:SetFont(CLEAR_FONT_BOLD, 10);				--  12		--  ***LedMirage 4/21/2006
   GameFontHighlightSmallOutline:SetFont(CLEAR_FONT_BOLD, 10, "OUTLINE");	--  12		--  ***LedMirage 4/21/2006


-- Large Game Fonts: titles
---------------------------

   GameFontNormalLarge:SetFont(CLEAR_FONT, 17);
   GameFontHighlightLarge:SetFont(CLEAR_FONT, 17);

   GameFontDisableLarge:SetFont(CLEAR_FONT, 17);
   GameFontDisableLarge:SetTextColor(0.6, 0.6, 0.6);

   GameFontGreenLarge:SetFont(CLEAR_FONT, 17);
   GameFontRedLarge:SetFont(CLEAR_FONT, 17);


-- Number Fonts: used in Auction House, money, keybinding, & quantity overlays
------------------------------------------------------------------------------

   NumberFontNormal:SetFont(CLEAR_FONT_NUMBER, 14, "OUTLINE");
   NumberFontNormalYellow:SetFont(CLEAR_FONT_NUMBER, 14, "OUTLINE");
   NumberFontNormalSmall:SetFont(CLEAR_FONT_NUMBER, 12, "OUTLINE");		--  ***LedMirage 4/21/2006
   NumberFontNormalSmallGray:SetFont(CLEAR_FONT_NUMBER, 10, "OUTLINE");	--  ***LedMirage 4/21/2006
   NumberFontNormalLarge:SetFont(CLEAR_FONT_NUMBER, 17, "OUTLINE");
   NumberFontNormalHuge:SetFont(CLEAR_FONT_NUMBER, 30, "THICKOUTLINE");


-- Chat window input font & chat window font sizes
--------------------------------------------------

   ChatFontNormal:SetFont(CLEAR_FONT_BOLDITALIC, 14);				--  ***LedMirage 4/21/2006

   CHAT_FONT_HEIGHTS = {
      [1] = 7,
      [2] = 8,
      [3] = 9,
      [4] = 10,
      [5] = 11,
      [6] = 12,
      [7] = 13,
      [8] = 14,
      [9] = 15,
      [10] = 16,
      [11] = 17,
      [12] = 18,
      [13] = 19,
      [14] = 20,
      [15] = 21,
      [16] = 22,
      [17] = 23,
      [18] = 24
   };


-- Quest Log: used in the quest log, books, and more
----------------------------------------------------

   QuestTitleFont:SetFont(CLEAR_FONT_BOLD, 19);
   QuestTitleFont:SetShadowColor(0.54, 0.4, 0.1);

   QuestFont:SetFont(CLEAR_FONT_ITALIC, 14);
   QuestFont:SetTextColor(0.15, 0.09, 0.04);

   QuestFontNormalSmall:SetFont(CLEAR_FONT_BOLD, 13);
   QuestFontNormalSmall:SetShadowColor(0.54, 0.4, 0.1);

   QuestFontHighlight:SetFont(CLEAR_FONT, 15);


-- Dialog Buttons: "Accept", etc.
---------------------------------

   DialogButtonNormalText:SetFont(CLEAR_FONT, 17);
   DialogButtonHighlightText:SetFont(CLEAR_FONT, 17);


-- Error Log: "Another Action is in Progress", etc.
---------------------------------------------------

   CombatLogFont:SetFont(CLEAR_FONT, 13);


-- Error Messages: window that pops up when bad things happen
-------------------------------------------------------------

   ErrorFont:SetFont(CLEAR_FONT, 16);


-- Item Info: general usage in frames
-------------------------------------

   ItemTextFontNormal:SetFont(CLEAR_FONT, 17);


-- Mail & Invoice Text: in-game mails & Auction House invoices
--------------------------------------------------------------

   MailTextFontNormal:SetFont(CLEAR_FONT_ITALIC, 15);
   MailTextFontNormal:SetTextColor(0.15, 0.09, 0.04);
   MailTextFontNormal:SetShadowColor(0.54, 0.4, 0.1);
   MailTextFontNormal:SetShadowOffset(1, -1);

   InvoiceTextFontNormal:SetFont(CLEAR_FONT_ITALIC, 14);
   InvoiceTextFontNormal:SetTextColor(0.15, 0.09, 0.04);

   InvoiceTextFontSmall:SetFont(CLEAR_FONT_ITALIC, 12);
   InvoiceTextFontSmall:SetTextColor(0.15, 0.09, 0.04);


-- Spell Book: ability subtitles
--------------------------------

   SubSpellFont:SetFont(CLEAR_FONT_BOLD, 12);


-- Status Bars: Numbers on the unit frames, Damage Meters
---------------------------------------------------------

   TextStatusBarText:SetFont(CLEAR_FONT_NUMBER, 12, "OUTLINE");
   TextStatusBarTextSmall:SetFont(CLEAR_FONT_BOLDITALIC, 12);				--  ***LedMirage 4/21/2006


-- Tooltips
-----------

   GameTooltipText:SetFont(CLEAR_FONT, 13);								--  ***LedMirage 4/21/2006
   GameTooltipText:SetShadowColor(0, 0, 0);								--  ***LedMirage 4/21/2006 
   GameTooltipText:SetShadowOffset(1, -1);								--  ***LedMirage 4/21/2006
   GameTooltipTextSmall:SetFont(CLEAR_FONT_BOLDITALIC, 12);				--  ***LedMirage 4/21/2006
   GameTooltipTextSmall:SetShadowColor(0, 0, 0);						--  ***LedMirage 4/21/2006 
   GameTooltipTextSmall:SetShadowOffset(1, -1);							--  ***LedMirage 4/21/2006   
   GameTooltipHeaderText:SetFont(CLEAR_FONT_BOLD, 15);					--  ***LedMirage 4/21/2006
   GameTooltipHeaderText:SetShadowColor(0, 0, 0);						--  ***LedMirage 4/21/2006 
   GameTooltipHeaderText:SetShadowOffset(1, -1);						--  ***LedMirage 4/21/2006   



-- World Map: location titles
-----------------------------

   WorldMapTextFont:SetFont(CLEAR_FONT_BOLDITALIC, 102, "THICKOUTLINE");
   WorldMapTextFont:SetShadowColor(0, 0, 0);
   WorldMapTextFont:SetShadowOffset(1, -1);


-- Zone Changes: on-screen notifications
----------------------------------------

   ZoneTextFont:SetFont(CLEAR_FONT_BOLDITALIC, 102, "THICKOUTLINE");
   ZoneTextFont:SetShadowColor(0, 0, 0);
   ZoneTextFont:SetShadowOffset(1, -1);

   SubZoneTextFont:SetFont(CLEAR_FONT_BOLDITALIC, 32, "THICKOUTLINE");

end





-- =============================================================================
--  C. FUNCTION TO RELOAD EVERY TIME AN ADDON LOADS
--  They do like to mess up my addon!
-- =============================================================================

ClearFont:SetScript("OnEvent",
		    function() 
		       if (event == "ADDON_LOADED") then
			  ClearFont:ApplySystemFonts()
		       end
		    end);
ClearFont:RegisterEvent("ADDON_LOADED");





-- =============================================================================
--  D. APPLY ALL THE ABOVE ON FIRST RUN
--  To start the ball rolling
-- =============================================================================

ClearFont:ApplySystemFonts()
