-- =============================================================================
--  CLEARFONT BY KIRKBURN  v11000-4  12.04.06
--  Official website:  http://seis.bris.ac.uk/~gp3509/ClearFont/
-- =============================================================================
--  CLEARFONTADDONS.LUA - ADDON-SPECIFIC FONT OVERRIDES
-- =============================================================================
--  This is not a replacement for Step Two, but is merely an aid for it
--  If you do not require or wish to remove these overrides open ClearFont.toc
--  then delete the line "ClearFontAddons.lua"
-- =============================================================================





-- =============================================================================
--  A. CLEARFONT FRAME & FONT LOCALS FOR BREVITY LATER
--  Add your own font local, following the example (the last line)
--  Keep this section the same in both lua files for consistency
-- =============================================================================

ClearFontAddons = CreateFrame("Frame", "ClearFontAddons");

local CLEAR_FONT_BASE = "Interface\\AddOns\\Insomniax_Core\\Fonts\\";				--"Interface\\AddOns\\!ClearFont\\Fonts\\";	--  ***LedMirage 4/03/2006
local CLEAR_FONT = CLEAR_FONT_BASE .. "IX_Font_Bold.ttf";							--"ClearFont.ttf";						--  ***LedMirage 4/03/2006
local CLEAR_FONT_BOLD = CLEAR_FONT_BASE .. "Montreal_Bold.ttf";						--"ClearFontBold.ttf";					--  ***LedMirage 4/03/2006
local CLEAR_FONT_ITALIC = CLEAR_FONT_BASE .. "IX_Font_Bold_Italic.ttf";				--"ClearFontItalic.ttf";					--  ***LedMirage 4/03/2006
local CLEAR_FONT_BOLDITALIC = CLEAR_FONT_BASE .. "IX_Font_Bold_Italic.ttf";			--"ClearFontBoldItalic.ttf";				--  ***LedMirage 4/03/2006
local CLEAR_FONT_NUMBER = CLEAR_FONT_BASE .. "IX_Font_Bold_Italic.ttf";				--"ClearFont.ttf";						--  ***LedMirage 4/03/2006
local YOUR_FONT_STYLE = CLEAR_FONT_BASE .. "IX_Font_Bold_Italic.ttf";				--This is for the Chat font only				--  ***LedMirage 4/07/2006





-- =============================================================================
--  B. ADDON-SPECIFIC OVERRIDES SECTION, LATEST VERSION TESTED LISTED
-- =============================================================================
--  BMRecLevel, DamageMeters, eCastingBar, EngInventory, MonkeyQuest
--  MonkeySpeed, SuperInspect, TipBuddy, TitanHonorPlus
-- =============================================================================
--  These overrides may or may not work, I cannot guarantee their success
--  If you wish to add your own, check the addon .xml files for 'fontstring's
--  If the name is unique you can try adding info here
--  Please don't ask me for help on this though, you need to find out yourself
-- =============================================================================
--  Only edit the second section of each line, delete addon sections if required
--  See ClearFont.lua for more instructions
-- =============================================================================


-- Check existence of overridable fonts & change them (Iriel) 
-------------------------------------------------------------

local function CanSetFont(object) 
   return (type(object)=="table" 
	   and object.SetFont and object.IsObjectType 
	      and not object:IsObjectType("SimpleHTML")); 
end

function ClearFontAddons:ApplyAddOnFonts()


-- BMRecLevel 2.10
------------------

   if (CanSetFont(BMRecLevelWorldMapText)) then 	BMRecLevelWorldMapText:SetFont(CLEAR_FONT_BOLD, 13, "OUTLINE"); end
   if (CanSetFont(BMRecLevelText)) then 			BMRecLevelText:SetFont(CLEAR_FONT, 13); end
   if (CanSetFont(BhaldieRecLevelFont)) then 		BhaldieRecLevelFont:SetFont(CLEAR_FONT, 13); end


-- DamageMeters 4.2.0
---------------------

   if (CanSetFont(DamageMeters_TitleButtonText)) then DamageMeters_TitleButtonText:SetFont(CLEAR_FONT_BOLD, 12); end
   if (CanSetFont(DamageMeters_TotalButtonText)) then DamageMeters_TotalButtonText:SetFont(CLEAR_FONT_BOLD, 12); end
   if (CanSetFont(DMReportTypeButtonText)) then 	DMReportTypeButtonText:SetFont(CLEAR_FONT_BOLD, 12); end


-- eCastingBar (for 1.10)
-------------------------

   if (CanSetFont(eCastingBarFont)) then 			eCastingBarFont:SetFont(CLEAR_FONT_BOLD, 12); end
   if (CanSetFont(eCastingBarText)) then 			eCastingBarText:SetFont(CLEAR_FONT_BOLD, 12); end
   if (CanSetFont(eCastingBar_Time)) then 		eCastingBar_Time:SetFont(CLEAR_FONT_NUMBER, 12); end
   if (CanSetFont(eCastingBar_Delay)) then 		eCastingBar_Delay:SetFont(CLEAR_FONT_NUMBER, 12); end
   if (CanSetFont(eCastingBarDragButtonText)) then 	eCastingBarDragButtonText:SetFont(CLEAR_FONT, 12); end
   if (CanSetFont(eCastingBarMirrorDragButtonText)) then 	eCastingBarMirrorDragButtonText:SetFont(CLEAR_FONT, 12); end
   if (CanSetFont(eCastingBarSpellLengthText)) then 	eCastingBarSpellLengthText:SetFont(CLEAR_FONT_BOLD, 12); end


-- EngInventory 23.03.06
------------------------

   if (CanSetFont(EngInventory_BigFont)) then 		EngInventory_BigFont:SetFont(CLEAR_FONT, 16); end 


-- MonkeyQuest 2.3
------------------

  -- if (CanSetFont(MonkeyQuestFont)) then 			MonkeyQuestFont:SetFont(CLEAR_FONT, 12); end				--  ***LedMirage 4/07/2006
  -- if (CanSetFont(MonkeyQuestTitleFont)) then 		MonkeyQuestTitleFont:SetFont(CLEAR_FONT_BOLD, 16, "OUTLINE"); end		--  ***LedMirage 4/07/2006
  -- if (CanSetFont(MonkeyQuestTitleText)) then 		MonkeyQuestTitleText:SetFont(CLEAR_FONT_BOLD, 16); end		--  ***LedMirage 4/07/2006


-- MonkeySpeed 2.3
------------------

   if (CanSetFont(MonkeySpeedText)) then 			MonkeySpeedText:SetFont(CLEAR_FONT, 13); end


-- SuperInspect 1.18
--------------------

   if (CanSetFont(SuperInspect_NameText)) then 				SuperInspect_NameText:SetFont(CLEAR_FONT, 13); end 
   if (CanSetFont(SuperInspect_TitleText)) then 			SuperInspect_TitleText:SetFont(CLEAR_FONT, 11); end 
   if (CanSetFont(SuperInspect_BonusesText)) then 			SuperInspect_BonusesText:SetFont(CLEAR_FONT, 11); end 
   if (CanSetFont(SuperInspect_BonusesTextR)) then 			SuperInspect_BonusesTextR:SetFont(CLEAR_FONT, 11); end 
   if (CanSetFont(SIDurabilityNumberFont)) then 			SIDurabilityNumberFont:SetFont(CLEAR_FONT, 15, "OUTLINE"); end 
   if (CanSetFont(SINumberFontNormal)) then 				SINumberFontNormal:SetFont(CLEAR_FONT, 14, "THICKOUTLINE"); end 
   if (CanSetFont(SuperInspect_ButtonText)) then 			SuperInspect_ButtonText:SetFont(CLEAR_FONT, 12); end 
   if (CanSetFont(SuperInspect_HonorText)) then 			SuperInspect_HonorText:SetFont(CLEAR_FONT, 11); end 
   if (CanSetFont(SuperInspect_HonorTextLarge)) then 			SuperInspect_HonorTextLarge:SetFont(CLEAR_FONT, 13); end 
   if (CanSetFont(SuperInspect_HonorTextSmall)) then 			SuperInspect_HonorTextSmall:SetFont(CLEAR_FONT_BOLD, 10); end 
   if (CanSetFont(SuperInspect_HonorTextHighlightSmall)) then	SuperInspect_HonorTextHighlightSmall:SetFont(CLEAR_FONT_BOLD, 10); end 
   if (CanSetFont(SuperInspect_ButtonTextHighlight)) then		SuperInspect_ButtonTextHighlight:SetFont(CLEAR_FONT, 12); end 
   if (CanSetFont(SuperInspect_ButtonTextDisable)) then		SuperInspect_ButtonTextDisable:SetFont(CLEAR_FONT, 12); end 

   if (CanSetFont(SuperInspect_HonorFrameCurrentPVPTitle)) then 	SuperInspect_HonorFrameCurrentPVPTitle:SetFont(CLEAR_FONT_BOLD, 11); end 
   if (CanSetFont(SuperInspect_HonorFrameCurrentPVPRank)) then 	SuperInspect_HonorFrameCurrentPVPRank:SetFont(CLEAR_FONT, 10); end 
   if (CanSetFont(SuperInspect_HonorFrameHonorPercent)) then 	SuperInspect_HonorFrameHonorPercent:SetFont(CLEAR_FONT, 11); end 
   if (CanSetFont(SuperInspect_HonorFrameCurrentSessionTitle)) then	SuperInspect_HonorFrameCurrentSessionTitle:SetFont(CLEAR_FONT, 11); end 
   if (CanSetFont(SuperInspect_HonorFrameYesterdayTitle)) then 	SuperInspect_HonorFrameYesterdayTitle :SetFont(CLEAR_FONT, 11); end 
   if (CanSetFont(SuperInspect_HonorFrameThisWeekTitle)) then 	SuperInspect_HonorFrameThisWeekTitle:SetFont(CLEAR_FONT, 11); end 
   if (CanSetFont(SuperInspect_HonorFrameLastWeekTitle)) then 	SuperInspect_HonorFrameLastWeekTitle:SetFont(CLEAR_FONT, 11); end 
   if (CanSetFont(SuperInspect_HonorFrameLifeTimeTitle)) then 	SuperInspect_HonorFrameLifeTimeTitle:SetFont(CLEAR_FONT, 11); end 

   if (CanSetFont(SuperInspect_ItemBonusesTitle)) then 		SuperInspect_ItemBonusesTitle:SetFont(CLEAR_FONT, 11); end 
   if (CanSetFont(SuperInspect_ItemBonusesText)) then 		SuperInspect_ItemBonusesText:SetFont(CLEAR_FONT, 11); end 
   if (CanSetFont(SuperInspect_ItemBonusesTextR)) then 		SuperInspect_ItemBonusesTextR:SetFont(CLEAR_FONT, 11); end 

   if (CanSetFont(SuperInspect_MagicResText1)) then 			SuperInspect_MagicResText1:SetFont(CLEAR_FONT_NUMBER, 14, "OUTLINE"); end 
   if (CanSetFont(SuperInspect_MagicResText2)) then 			SuperInspect_MagicResText2:SetFont(CLEAR_FONT_NUMBER, 14, "OUTLINE"); end 
   if (CanSetFont(SuperInspect_MagicResText3)) then 			SuperInspect_MagicResText3:SetFont(CLEAR_FONT_NUMBER, 14, "OUTLINE"); end 
   if (CanSetFont(SuperInspect_MagicResText4)) then 			SuperInspect_MagicResText4:SetFont(CLEAR_FONT_NUMBER, 14, "OUTLINE"); end 
   if (CanSetFont(SuperInspect_MagicResText5)) then 			SuperInspect_MagicResText5:SetFont(CLEAR_FONT_NUMBER, 14, "OUTLINE"); end 

   if (CanSetFont(SuperInspect_SnTBonusesTitle)) then 		SuperInspect_SnTBonusesTitle:SetFont(CLEAR_FONT, 12); end 
   if (CanSetFont(SuperInspect_SnTBonusesText)) then 			SuperInspect_SnTBonusesText:SetFont(CLEAR_FONT, 11); end 

   if (CanSetFont(SuperInspect_MobInfoTitle)) then 			SuperInspect_MobInfoTitle:SetFont(CLEAR_FONT, 12); end 
   if (CanSetFont(SuperInspect_MobInfoText)) then 			SuperInspect_MobInfoText:SetFont(CLEAR_FONT, 11); end 
   if (CanSetFont(SuperInspect_MobInfoTextR)) then 			SuperInspect_MobInfoTextR:SetFont(CLEAR_FONT, 11); end 

   if (CanSetFont(SuperInspect_ItemBonusesNameCompare)) then 	SuperInspect_ItemBonusesNameCompare:SetFont(CLEAR_FONT, 12); end 
   if (CanSetFont(SuperInspect_ItemBonusesGuildCompare)) then 	SuperInspect_ItemBonusesGuildCompare:SetFont(CLEAR_FONT, 10); end 
   if (CanSetFont(SuperInspect_ItemBonusesTitleCompare)) then 	SuperInspect_ItemBonusesTitleCompare:SetFont(CLEAR_FONT, 12); end 
   if (CanSetFont(SuperInspect_ItemBonusesTextCompare)) then 	SuperInspect_ItemBonusesTextCompare:SetFont(CLEAR_FONT, 11); end 
   if (CanSetFont(SuperInspect_ItemBonusesTextRCompare)) then 	SuperInspect_ItemBonusesTextRCompare:SetFont(CLEAR_FONT, 11); end 

   if (CanSetFont(SuperInspect_MagicResTextCompare1)) then 		SuperInspect_MagicResTextCompare1:SetFont(CLEAR_FONT_NUMBER, 14, "OUTLINE"); end 
   if (CanSetFont(SuperInspect_MagicResTextCompare2)) then 		SuperInspect_MagicResTextCompare2:SetFont(CLEAR_FONT_NUMBER, 14, "OUTLINE"); end 
   if (CanSetFont(SuperInspect_MagicResTextCompare3)) then 		SuperInspect_MagicResTextCompare3:SetFont(CLEAR_FONT_NUMBER, 14, "OUTLINE"); end 
   if (CanSetFont(SuperInspect_MagicResTextCompare4)) then 		SuperInspect_MagicResTextCompare4:SetFont(CLEAR_FONT_NUMBER, 14, "OUTLINE"); end 
   if (CanSetFont(SuperInspect_MagicResTextCompare5)) then 		SuperInspect_MagicResTextCompare5:SetFont(CLEAR_FONT_NUMBER, 14, "OUTLINE"); end 

   if (CanSetFont(SI_DummyText)) then 					SI_DummyText:SetFont(CLEAR_FONT, 13); end 


-- TipBuddy 2.1
---------------

   if (CanSetFont(TBGameFontNormal)) then 				TBGameFontNormal:SetFont(CLEAR_FONT, 11); end 
   if (CanSetFont(TBGameFontHighlight)) then 				TBGameFontHighlight:SetFont(CLEAR_FONT, 11); end 
   if (CanSetFont(TBGameFontDisable)) then 				TBGameFontDisable:SetFont(CLEAR_FONT, 11); end 
   if (CanSetFont(TBGameFontNormalSmall)) then 				TBGameFontNormalSmall:SetFont(CLEAR_FONT, 9); end 
   if (CanSetFont(TBGameFontHighlightSmall)) then 			TBGameFontHighlightSmall:SetFont(CLEAR_FONT, 9); end
   if (CanSetFont(ToolTipBuddyText)) then 				ToolTipBuddyText:SetFont(CLEAR_FONT, 12); end
   if (CanSetFont(ToolTipBuddyTextOutline)) then 			ToolTipBuddyTextOutline:SetFont(CLEAR_FONT, 16, "OUTLINE"); end 
   if (CanSetFont(TB_HealthText)) then 					TB_HealthText:SetFont(CLEAR_FONT_NUMBER, 15, "OUTLINE"); end 
   if (CanSetFont(TB_ManaText)) then 					TB_ManaText:SetFont(CLEAR_FONT_NUMBER, 13, "OUTLINE"); end 
   if (CanSetFont(TB_TTGameFontNormalSmall)) then 			TB_TTGameFontNormalSmall:SetFont(CLEAR_FONT, 10); end
   if (CanSetFont(TB_TTGameFontNormalSmallHighlight)) then		TB_TTGameFontNormalSmall:SetFont(CLEAR_FONT, 10); end 


-- TitanHonorPlus (for 1.10)
----------------------------

   if (CanSetFont(TitanHonorPlus_TipBuddy_TargetName_Text)) then 	TitanHonorPlus_TipBuddy_TargetName_Text:SetFont(CLEAR_FONT, 12); end 


end





-- =============================================================================
--  C. FUNCTION TO RELOAD EVERY TIME AN ADDON LOADS
--  They do like to mess up my addon!
-- =============================================================================

ClearFontAddons:SetScript("OnEvent",
		    function() 
		       if (event == "ADDON_LOADED") then
			  ClearFontAddons:ApplyAddOnFonts()
		       end
		    end);
ClearFontAddons:RegisterEvent("ADDON_LOADED");





-- =============================================================================
--  D. APPLY ALL THE ABOVE ON FIRST RUN
--  To start the ball rolling
-- =============================================================================

ClearFontAddons:ApplyAddOnFonts()
