--[[
	Slash
		This is the slash command handler for Bagnon
--]]

function BagnonSlash_Load()
	SlashCmdList["BagnonCOMMAND"] = BagnonSlash;
	SLASH_BagnonCOMMAND1 = "/bagnon";
	SLASH_BagnonCOMMAND2 = "/bgn";
end

function BagnonSlash(msg)
	local msg = string.lower(msg);
	if(msg == "" or msg == BAGNON_COMMAND_HELP) then
		BagnonSlash_DisplayHelp();
	elseif(msg == BAGNON_COMMAND_SHOWBANK) then
		BagnonCore_Toggle("Banknon");
	elseif(msg == BAGNON_COMMAND_SHOWBAGS) then
		BagnonCore_Toggle("Bagnon");
	elseif(msg == BAGNON_COMMAND_OVERRIDE_BANK) then
		BagnonSets_ToggleBankOverride();
	elseif(msg == BAGNON_COMMAND_TOGGLE_TOOLTIPS) then
		BagnonSets_ToggleTooltips();
	elseif(msg == "debug") then
		BagnonSets.noDebug = nil;
		BagnonMsg("Debug mode enabled.");
	elseif(msg == "nodebug") then
		BagnonSets.noDebug = 1;
		BagnonMsg("Debug mode disabled.");
	end
end

function BagnonSlash_DisplayHelp()
	BagnonMsg(BAGNON_HELP_TITLE);
	BagnonMsg(BAGNON_HELP_HELP);
	BagnonMsg(BAGNON_HELP_SHOWBAGS);
	BagnonMsg(BAGNON_HELP_SHOWBANK);
	BagnonMsg(BAGNON_HELP_OVERRIDE_BANK);
	BagnonMsg(BAGNON_HELP_TOGGLE_TOOLTIPS);
end

function BagnonSets_ToggleBankOverride()
	if(BagnonSets.overrideBank == nil) then
		BagnonSets.overrideBank = 1;
		BagnonMsg(BAGNON_BANK_OVERRIDDEN);
	else
		BagnonSets.overrideBank = nil;
		BagnonMsg(BAGNON_BANK_NORMAL);
	end
end

function BagnonSets_ToggleTooltips()
	if(BagnonSets.showTooltips == nil) then
		BagnonSets.showTooltips = 1;
		BagnonMsg(BAGNON_TOOLTIPS_ENABLED);
	else
		BagnonSets.showTooltips = nil;
		BagnonMsg(BAGNON_TOOLTIPS_DISABLED);
	end
end