--[[
	Bagnon Localization file
	
	TODO:
		Add some frame strings and other things
		I could probably Babelfish the translation, but most likely it would insult someone's 
			mother or something.
--]]

BAGNON_VERSION = "4196";

--[[
	English - Default Language
--]]

--[[ Keybindings ]]--

BINDING_HEADER_BAGNON = "Bagnon";
BINDING_NAME_BAGNON_TOGGLE = "Toggle Bagnon";
BINDING_NAME_BANKNON_TOGGLE = "Toggle Banknon";

--[[ Slash Commands ]]--

BAGNON_COMMAND_HELP = "help";
BAGNON_COMMAND_SHOWBAGS = "bags";
BAGNON_COMMAND_SHOWBANK = "bank";
BAGNON_COMMAND_REVERSE = "reverse";
BAGNON_COMMAND_OVERRIDE_BANK = "overridebank";
BAGNON_COMMAND_TOGGLE_TOOLTIPS = "tooltips";

--[[ Messages from the slash commands ]]--

--/bgn help
BAGNON_HELP_TITLE = "Bagnon commands:";
BAGNON_HELP_SHOWBAGS = "/bgn " .. BAGNON_COMMAND_SHOWBAGS .. " - Show/Hide Bagnon.";
BAGNON_HELP_SHOWBANK = "/bgn " .. BAGNON_COMMAND_SHOWBANK .. " - Show/Hide Banknon.";
BAGNON_HELP_OVERRIDE_BANK = "/bgn " .. BAGNON_COMMAND_OVERRIDE_BANK .. " - Toggle the use of the normal bank frame when talking to a NPC.";
BAGNON_HELP_TOGGLE_TOOLTIPS = "/bgn " .. BAGNON_COMMAND_TOGGLE_TOOLTIPS .. " - Turn help tooltips on or off.";
BAGNON_HELP_HELP = "/bgn " .. BAGNON_COMMAND_HELP .. " - Display slash commands.";


--/bgn overridebank
BAGNON_BANK_OVERRIDDEN = "Banknon will now be opened when you talk to a bank NPC.";
BAGNON_BANK_NORMAL = "The default bank frame will now open whenever you talk to a bank NPC.";

--/bgn tooltips
BAGNON_TOOLTIPS_ENABLED = "Tooltips to display help information are now enabled.";
BAGNON_TOOLTIPS_DISABLED = "Tooltips to display help tooltips are now disabled.";

--[[ System Messages ]]--

BAGNON_INITIALIZED = "Bagnon initialized.  Type /bagnon or /bgn for commands";
BAGNON_UPDATED = "Bagnon Settings updated to v" .. BAGNON_VERSION .. ".  Type /bagnon or /bgn for commands";

--[[ UI Text ]]--

--Titles

--These should probably read Inventory of <player> and Bank of <player> in other versions I guess
BAGNON_INVENTORY_TITLE = "%s's Inventory";
BAGNON_BANK_TITLE = "%s's Bank";

--Bag Button
BAGNON_SHOWBAGS = "Show Bags";
BAGNON_HIDEBAGS = "Hide Bags";

--Options Menu
BAGNON_OPTIONS_TITLE = "%s Settings";
BAGNON_OPTIONS_LOCK = "Lock Position";
BAGNON_OPTIONS_BACKGROUND = "Background";
BAGNON_OPTIONS_REVERSE = "Reverse Bag Ordering";
BAGNON_OPTIONS_COLUMNS = "Columns";
BAGNON_OPTIONS_SPACING = "Spacing";
BAGNON_OPTIONS_SCALE = "Scale";
BAGNON_OPTIONS_OPACITY = "Opacity";
BAGNON_OPTIONS_STRATA = "Layer";

--[[ Tooltips ]]--

--Title tooltip
BAGNON_TITLE_TOOLTIP = "<Right-Click> to open up the settings menu.";
BAGNON_TITLE_FOREVERTOOLTIP = "<Double-Click> to switch characters.";

--Bag Tooltips
BAGNON_BAGS_HIDE = "<Shift-Click> to hide.";
BAGNON_BAGS_SHOW = "<Shift-Click> to show.";

--[[ Other ]]--

--fifth return for GetItemInfo(id)
BAGNON_ITEMTYPE_CONTAINER = "Container";
BAGNON_ITEMTYPE_QUIVER = "Quiver";
--sixth return for GetItemInfo(id)
BAGNON_SUBTYPE_SOULBAG = "Soul Bag";
BAGNON_SUBTYPE_BAG = "Bag";


--[[
	German
		Credit goes to Sarkan on Curse
--]]


if ( GetLocale() == "deDE" ) then
	--[[ Keybindings ]]--

	BINDING_HEADER_BAGNON = "Bagnon";
	BINDING_NAME_BAGNON_TOGGLE = "Zeige Bagnon";
	BINDING_NAME_BANKNON_TOGGLE = "Zeige Banknon";

	--[[ Slash Commands ]]--

	--[[
		These may or may not work, so I've decided to disable non english versions of slash commands
		
		BAGNON_COMMAND_HELP = "hilfe";
		BAGNON_COMMAND_SHOWBAGS = "taschen";
		BAGNON_COMMAND_SHOWBANK = "bank";
		BAGNON_COMMAND_REVERSE = "umgekehrt";
		BAGNON_COMMAND_OVERRIDE_BANK = "bank ansicht \195\164ndern";
	--]]

	--[[ Messages from the slash commands ]]--

	--/bgn help
	BAGNON_HELP_TITLE = "Bagnon Kommandos:";
	BAGNON_HELP_SHOWBAGS = "/bgn " .. BAGNON_COMMAND_SHOWBAGS .. " - Zeige/Verstecke Bagnon.";
	BAGNON_HELP_SHOWBANK = "/bgn " .. BAGNON_COMMAND_SHOWBANK .. " - Zeige/Verstecke Banknon.";
	BAGNON_HELP_OVERRIDE_BANK = "/bgn " .. BAGNON_COMMAND_OVERRIDE_BANK .. " - Aktiviere um normale Bank Ansicht bei Gespr\195\164ch mit NPC zu \195\164ndern";
	BAGNON_HELP_HELP = "/bgn " .. BAGNON_COMMAND_HELP .. " - Zeige Slash Kommandos.";


	--/bgn override bank
	BAGNON_BANK_OVERRIDDEN = "Banknon wird jetzt ausgef\195\188hrt wenn mit dem Bankier gesprochen wird.";
	BAGNON_BANK_NORMAL = "Die Standard Ansicht wird ausgef\195\188hrt wenn mit dem Bankier gesprochen wird.";

	--[[ System Messages ]]--

	BAGNON_INITIALIZED = "Bagnon inizialisiert. Bitte /bagnon oder /bgn f\195\188r Kommandos";
	BAGNON_UPDATED = "Bagnon Einstellungen aktualisiert auf v" .. BAGNON_VERSION .. ". Bitte /bagnon oder /bgn f\195\188r Kommandos";

	--[[ UI Text ]]--

	--Titles

	--These should probably read Inventory of <player> and Bank of <player> in other versions I guess
	BAGNON_INVENTORY_TITLE = "%s's Inventar";
	BAGNON_BANK_TITLE = "%s's Bank";

	--Bag Button
	BAGNON_SHOWBAGS = "+ Taschen";
	BAGNON_HIDEBAGS = "- Taschen";

	--Options Menu
	BAGNON_OPTIONS_TITLE = "%s Einstellungen";
	BAGNON_OPTIONS_LOCK = "Fixiere Position";
	BAGNON_OPTIONS_BACKGROUND = "Hintergrund";
	BAGNON_OPTIONS_REVERSE = "Drehe Taschenanordnung um";
	BAGNON_OPTIONS_COLUMNS = "Spalte";
	BAGNON_OPTIONS_SPACING = "Abstand";
	BAGNON_OPTIONS_SCALE = "Masstab";
	BAGNON_OPTIONS_OPACITY = "Transparenz";
	BAGNON_OPTIONS_STRATA = "Layer";

	--[[ Tooltips ]]--

	--Title tooltip
	BAGNON_TITLE_TOOLTIP = "<Rechts-Klick> Um Einstellungs Men\195\188 zu zeigen";
	BAGNON_TITLE_FOREVERTOOLTIP = "<Doppel-Klick> um Charakter zu wechseln.";

	--Bag Tooltips
	BAGNON_BAGS_HIDE = "<Shift-Klick> zum verstecken.";
	BAGNON_BAGS_SHOW = "<Shift-Klick> zum zeigen.";

	--[[ Other ]]--
	--this should be the sixth return value for a bag from GetItemInfo()
	BAGNON_ITEMTYPE_CONTAINER = "Beh\195\164lter";
	BAGNON_ITEMTYPE_QUIVER = "K\195\182cher";
	BAGNON_SUBTYPE_SOULBAG = "Seelentasche";
	BAGNON_SUBTYPE_BAG = "Beh\195\164lter";
	return;
end

--[[
	French
--]]

if ( GetLocale() == "frFR" ) then
	BAGNON_SUBTYPE_BAG = "Conteneur";
	return;
end