--[[
		Bagnon_Menu
			Functions for the dropdown menu for Bagnon_Forever

		Essentially the dropdown is used to switch between the inventory of other characters
		Why not use a normal dropdown?  It takes a lot of memory
--]]

--[[ Dropdown Menus --]]--

function BagnonForeverMenu_Show(frame)
	BagnonForeverMenu.frame = frame;
	
	--update button info
	local button, player;
	local index = 0;
		
	for player in BagnonDB[GetRealmName()] do
		index = index + 1;

		button = getglobal("BagnonForeverMenu" .. index);
		if(not button) then
			index = index - 1;
			break;
		end
		button:SetText(player);

		if(frame.player == player) then
			button:SetChecked(true);
			button:Show();
		else
			button:SetChecked(false);
		end
	end
		
	local i = index + 1;
	while getglobal("BagnonForeverMenu" .. i) do
		getglobal("BagnonForeverMenu" .. i):Hide();
		i = i + 1;
	end
		
	
	--resize and position the frame
	BagnonForeverMenu:SetHeight(38 + index * 20);
	local x, y = GetCursorPosition();
	x = x / UIParent:GetScale();
	y = y / UIParent:GetScale();

	BagnonForeverMenu:ClearAllPoints();
	Infield.Place(BagnonForeverMenu, "TOPLEFT", UIParent, "BOTTOMLEFT", x, y);
	BagnonForeverMenu:Show();
end


function BagnonForeverMenu_ChangeCharacter(character)
	local frame = this:GetParent().frame;
	local frameTitle = getglobal(frame:GetName() .. "Title");
	
	frameTitle:SetText( string.format(frame.title, character ) );
	frame.player = character
	BagnonCore_GenerateFrame(frame);
	
	local bags = { getglobal(frame:GetName() .. "Bags"):GetChildren() };
	for bag in bags do
		BagnonBag_UpdateTexture(frame, bags[bag]:GetID());
	end
	
	this:GetParent():Hide();
end

function BagnonForeverMenuButton_OnClick()
	BagnonForeverMenu_ChangeCharacter(this:GetText());
end