--Number of Bib Action Bars
BIB_ACTION_BAR_COUNT = 10;

--Keeps track of our current action button page
CURRENT_BIB_ACTIONBAR_PAGE = 1;

--Keeps track of whether we have a pet with an action bar
PET_WITH_ACTION_BAR = nil;

BIB_BUTTON_GRID_SHOW = nil;
BIB_BUTTON_GRID_HIDE_AND_CASCADE = 1;
BIB_BUTTON_GRID_HIDE_NO_CASCADE = 2;


BibActionBarCount = 0;
BibActionBarsInitialized = 0;
AllBibActionBarsLoaded = false;

-- LedMirage 1.31.2006
-- Function replacement to get custom button textures
function ActionButton_Update()
	-- Special case code for bonus bar buttons
	-- Prevents the button from updating if the bonusbar is still in an animation transition
	if ( this.isBonus and this.inTransition ) then
		ActionButton_UpdateUsable();
		ActionButton_UpdateCooldown();
		return;
	end
	
	local icon = getglobal(this:GetName().."Icon");
	local buttonCooldown = getglobal(this:GetName().."Cooldown");
	local texture = GetActionTexture(ActionButton_GetPagedID(this));
	if ( texture ) then
		icon:SetTexture(texture);
		icon:Show();
		this.rangeTimer = -1;
		-- Custom Insomniax Texture
		this:SetNormalTexture("Interface\\AddOns\\Insomniax_BibToolbars\\Images\\Insomniax_Quickslot_Up");
		getglobal(this:GetName().."NormalTexture"):SetVertexColor(0.85, 0.85, 0.85, 1.0);
		-- Save texture if the button is a bonus button, will be needed later
		if ( this.isBonus ) then
			this.texture = texture;
		end
	else
		icon:Hide();
		buttonCooldown:Hide();
		this.rangeTimer = nil;
		-- Custom Insomniax Texture
		this:SetNormalTexture("Interface\\AddOns\\Insomniax_BibToolbars\\Images\\Insomniax_Quickslot_Down");
		--getglobal(this:GetName().."Button"):SetVertexColor(1, 1, 1, 1.0);
		getglobal(this:GetName().."NormalTexture"):SetVertexColor(0.85, 0.85, 0.85, 1.0);
		getglobal(this:GetName().."HotKey"):SetVertexColor(0.6, 0.6, 0.6);
	end
	ActionButton_UpdateCount();
	if ( HasAction(ActionButton_GetPagedID(this)) ) then
		this:RegisterEvent("ACTIONBAR_UPDATE_STATE");
		this:RegisterEvent("ACTIONBAR_UPDATE_USABLE");
		this:RegisterEvent("ACTIONBAR_UPDATE_COOLDOWN");
		this:RegisterEvent("UPDATE_INVENTORY_ALERTS");
		this:RegisterEvent("PLAYER_AURAS_CHANGED");
		this:RegisterEvent("PLAYER_TARGET_CHANGED");
		this:RegisterEvent("UNIT_INVENTORY_CHANGED");
		this:RegisterEvent("CRAFT_SHOW");
		this:RegisterEvent("CRAFT_CLOSE");
		this:RegisterEvent("TRADE_SKILL_SHOW");
		this:RegisterEvent("TRADE_SKILL_CLOSE");
		this:RegisterEvent("PLAYER_ENTER_COMBAT");
		this:RegisterEvent("PLAYER_LEAVE_COMBAT");
		this:RegisterEvent("START_AUTOREPEAT_SPELL");
		this:RegisterEvent("STOP_AUTOREPEAT_SPELL");

		this:Show();
		ActionButton_UpdateState();
		ActionButton_UpdateUsable();
		ActionButton_UpdateCooldown();
		ActionButton_UpdateFlash();
	else
		this:UnregisterEvent("ACTIONBAR_UPDATE_STATE");
		this:UnregisterEvent("ACTIONBAR_UPDATE_USABLE");
		this:UnregisterEvent("ACTIONBAR_UPDATE_COOLDOWN");
		this:UnregisterEvent("UPDATE_INVENTORY_ALERTS");
		this:UnregisterEvent("PLAYER_AURAS_CHANGED");
		this:UnregisterEvent("PLAYER_TARGET_CHANGED");
		this:UnregisterEvent("UNIT_INVENTORY_CHANGED");
		this:UnregisterEvent("CRAFT_SHOW");
		this:UnregisterEvent("CRAFT_CLOSE");
		this:UnregisterEvent("TRADE_SKILL_SHOW");
		this:UnregisterEvent("TRADE_SKILL_CLOSE");
		this:UnregisterEvent("PLAYER_ENTER_COMBAT");
		this:UnregisterEvent("PLAYER_LEAVE_COMBAT");
		this:UnregisterEvent("START_AUTOREPEAT_SPELL");
		this:UnregisterEvent("STOP_AUTOREPEAT_SPELL");

		if ( this.showgrid == 0 ) then
			this:Hide();
		else
			buttonCooldown:Hide();
		end
	end

	-- Add a green border if button is an equipped item
	local border = getglobal(this:GetName().."Border");
	if ( IsEquippedAction(ActionButton_GetPagedID(this)) ) then
		-- LedMirage 2.07.2006
		border:SetVertexColor(0, 1.0, 0, 0.85);
		border:Show();
	else
		border:Hide();
	end

	if ( GameTooltip:IsOwned(this) ) then
		ActionButton_SetTooltip();
	else
		this.updateTooltip = nil;
	end

	-- Update Macro Text
	local macroName = getglobal(this:GetName().."Name");
	macroName:SetText(GetActionText(ActionButton_GetPagedID(this)));
end

--Triggers the BibActionBarManagement to redraw the given action bar
function RedrawBibActionBar(actionBarName)
	BibActionBarManagement.RedrawActionBars[actionBarName] = true;
	BibActionBarManagement.ActionBarRedrawTriggered = true;
end


function RedrawAllBibActionBars()
	for key, value in BibActionBarManagement.RedrawActionBars do
		BibActionBarManagement.RedrawActionBars[key] = true;
	end
	BibActionBarManagement.ActionBarRedrawTriggered = true;
	-- LedMirage Redraw Update to preserve custom opacity needs to be added
	-- calling ActionButton_Update again causes errors
	-- ActionButton_Update();
end


function showEmptyButton(button)
	getglobal(button:GetName().."Icon"):Hide();
	getglobal(button:GetName().."Count"):Hide();
	getglobal(button:GetName().."Name"):Hide();
	-- LedMirage 2.07.2006  Custom Insomniax Texture 
	--button:SetNormalTexture("Interface\\AddOns\\Insomniax_BibToolbars\\Images\\Insomniax_Quickslot_Down");
	--getglobal(button:GetName().."NormalTexture"):SetVertexColor(0.85, 0.85, 0.85, 1.0);

	if(button.showgrid < 1) then
		button:Hide();
	end
end


function showOccupiedButton(button)
	getglobal(button:GetName().."Icon"):Show();
	getglobal(button:GetName().."Count"):Show();
	getglobal(button:GetName().."Name"):Show();
	button:Hide();
	button:Show();
	button:SetNormalTexture("Interface\\AddOns\\Insomniax_BibToolbars\\Images\\Insomniax_Quickslot_Up");
	getglobal(button:GetName().."NormalTexture"):SetVertexColor(0.85, 0.85, 0.85, 1.0);
end


function BibRotateActionBar(bar_name)
	SetHashedSaveValue("ActionBarOrientations", bar_name,
		math.mod(GetHashedSaveValue("ActionBarOrientations", bar_name) + 1, 13));
	LayoutBibActionBar(bar_name);
end


function RemoveMainActionBar()
	MainMenuBarTexture0:Hide();
	MainMenuBarTexture1:Hide();
	MainMenuBarTexture2:Hide();
	MainMenuBarTexture3:Hide();
	MainMenuBarLeftEndCap:Hide();
	MainMenuBarRightEndCap:Hide();
	MainMenuBarOverlayFrame:Hide();
	MainMenuBar:SetPoint("BOTTOM", "UIParent", "BOTTOM", 0, -100);
	ActionBarUpButton:Hide();
	ActionBarDownButton:Hide();
	ExhaustionTick:Hide();
	BonusActionBarTexture0:ClearAllPoints();
	BonusActionBarTexture0:SetPoint("BOTTOM", "UIParent", "BOTTOM", 0, -100);
	BonusActionBarFrame:ClearAllPoints();
	BonusActionBarFrame:SetPoint("BOTTOM", "UIParent", "BOTTOM", 0, -100);
	SlidingActionBarTexture0:ClearAllPoints();
	SlidingActionBarTexture0:SetPoint("BOTTOM", "UIParent", "BOTTOM", 0, -100);
	MainMenuExpBar:ClearAllPoints();
	MainMenuExpBar:SetPoint("BOTTOM", "UIParent", "BOTTOM", 0, -100);
	local actionbutton;
	for i = 1, 12 do
		actionbutton = getglobal("ActionButton"..i);
		actionbutton:ClearAllPoints();
		actionbutton:SetPoint("BOTTOM", "UIParent", "BOTTOM", 0, -100)
	end
end


function LayoutBibActionBar(ActionBarName)
	local action_button;
	local ActionBar = getglobal(ActionBarName);
	local ActionBarID = ActionBar:GetID();
	local orientation = GetHashedSaveValue("ActionBarOrientations", ActionBarName);
	local n = 0;
	local x_offset = 0;
	local y_offset = 0;
	local max_x_offset = 0;
	local max_y_offset = 0;
	local visible_buttons_exist = false;

	i = 1;
	for j=1, 12 do
		action_button = getglobal(GetBibActionButtonName(j + (ActionBarID-1)*12));
		action_button:ClearAllPoints();
		if(orientation == 0) then
			action_button:SetPoint("BOTTOM", "UIParent", "BOTTOM", 0, -100);
		else
			action_button:SetPoint("TOPLEFT", ActionBarName, "TOPLEFT", x_offset , -y_offset);
			if(action_button:IsVisible()) then
				if(x_offset > max_x_offset) then
					max_x_offset = x_offset;
				end
				if(y_offset > max_y_offset) then
					max_y_offset = y_offset;
				end
				if(not visible_buttons_exist) then
					visible_buttons_exist = true;
				end
			end
		end

		if(action_button:IsVisible() or BibButtonsGridMode == BIB_BUTTON_GRID_HIDE_NO_CASCADE) then
			i = i + 1;
			-- test 39 to 40
			x_offset = (math.mod(i - 1, orientation)) * 40;
			y_offset = floor((i-1) / (orientation)) * 40;
		end
	end

	if (not visible_buttons_exist) then
		ActionBar:SetWidth(12);
		ActionBar:SetHeight(20);
	else
		ActionBar:SetWidth(max_x_offset + 36);
		ActionBar:SetHeight(max_y_offset + 36);
	end
end


function ConstructBibMicroBar()
	CharacterMicroButton:ClearAllPoints();
	CharacterMicroButton:SetPoint("TOPLEFT", "MainMenuBarArtFrame", "TOPLEFT", -2, 22);
end


function ConstructBibBagBar()
	CharacterBag3Slot:ClearAllPoints();
	CharacterBag3Slot:SetPoint("BOTTOMLEFT", this:GetName());
	CharacterBag2Slot:ClearAllPoints();
	CharacterBag2Slot:SetPoint("LEFT", "CharacterBag3Slot", "RIGHT", 2, 0);
	CharacterBag1Slot:ClearAllPoints();
	CharacterBag1Slot:SetPoint("LEFT", "CharacterBag2Slot", "RIGHT", 2, 0);
	CharacterBag0Slot:ClearAllPoints();
	CharacterBag0Slot:SetPoint("LEFT", "CharacterBag1Slot", "RIGHT", 2, 0);
	MainMenuBarBackpackButton:ClearAllPoints();
	MainMenuBarBackpackButton:SetPoint("LEFT", "CharacterBag0Slot", "RIGHT", 2, 0);
end


function BibConstructPetBar()
	for i=1, 10 do
		pet_button = getglobal("PetActionButton"..i);
		if (pet_button ~= nil) then
			pet_button:SetFrameStrata(BibPetActionBarDragButton:GetFrameStrata());		--  ***LedMirage 4.01.2006
			pet_button:ClearAllPoints();
			pet_button:SetPoint("TOPLEFT", "PetActionBarFrame", "TOPLEFT", 2 + ((i - 1) * 33), -1);
			-- LedMirage 2.07.2006
			pet_button:SetNormalTexture("Interface\\AddOns\\Insomniax_BibToolbars\\Images\\Insomniax_Quickslot_Down");
		end
	end
end

function ConstructBibShapeshiftBar()
	for i=1, 10 do
		shapeshift_button = getglobal("ShapeshiftButton"..i);
		shapeshift_button:ClearAllPoints();
		shapeshift_button:SetPoint("TOPLEFT", "ShapeshiftBarFrame", "TOPLEFT", 4 + ((i - 1) * 39), -4);
			-- LedMirage 2.07.2006
			shapeshift_button:SetNormalTexture("Interface\\AddOns\\Insomniax_BibToolbars\\Images\\Insomniax_Quickslot_Down");		
	end
end


function PetActionBarFrame_OnUpdate(elapsed)
	local yPos;
	if ( this.slideTimer and (this.slideTimer < this.timeToSlide) ) then
		this.completed = nil;
		if ( this.mode == "show" ) then
			yPos = (this.slideTimer/this.timeToSlide) * this.yTarget;
			this.state = "showing";
			this:Show();
		elseif ( this.mode == "hide" ) then
			yPos = (1 - (this.slideTimer/this.timeToSlide)) * this.yTarget;
			this.state = "hiding";
		end
		this.slideTimer = this.slideTimer + elapsed;
	else
		this.completed = 1;
		if ( this.mode == "show" ) then
			this.state = "top";
		elseif ( this.mode == "hide" ) then
			this.state = "bottom";
			this:Hide();
		end
		this.mode = "none";
	end
end


-- LedMirage 1.31.2006
function PetActionBar_Update()
	local petActionButton, petActionIcon;
	local petActionsUsable = GetPetActionsUsable();
	for i=1, NUM_PET_ACTION_SLOTS, 1 do
		petActionButton = getglobal("PetActionButton"..i);
		-- LedMirage 2.07.2006 Test
		-- button:SetNormalTexture("Interface\\AddOns\\Insomniax_BibToolbars\\Images\\Insomniax_Quickslot_Down");
		-- getglobal(button:GetName().."NormalTexture"):SetVertexColor(0.85, 0.85, 0.85, 1.0);
		
		petActionIcon = getglobal("PetActionButton"..i.."Icon");
		petAutoCastableTexture = getglobal("PetActionButton"..i.."AutoCastable");
		petAutoCastModel = getglobal("PetActionButton"..i.."AutoCast");
		local name, subtext, texture, isToken, isActive, autoCastAllowed, autoCastEnabled = GetPetActionInfo(i);
		if ( not isToken ) then
			petActionIcon:SetTexture(texture);
			petActionButton.tooltipName = name;
		else
			petActionIcon:SetTexture(getglobal(texture));
			petActionButton.tooltipName = TEXT(getglobal(name));
		end
		petActionButton.isToken = isToken;
		petActionButton.tooltipSubtext = subtext;
		if ( isActive ) then
			petActionButton:SetChecked(1);
		else
			petActionButton:SetChecked(0);
		end
		if ( autoCastAllowed ) then
			petAutoCastableTexture:Show();
		else
			petAutoCastableTexture:Hide();
		end
		if ( autoCastEnabled ) then
			petAutoCastModel:Show();
		else
			petAutoCastModel:Hide();
		end
		if ( name ) then
			petActionButton:Show();
		else
			if ( PetActionBarFrame.showgrid == 0 ) then
				petActionButton:Hide();
			end
		end
		if ( texture ) then
			if ( petActionsUsable ) then
				SetDesaturation(petActionIcon, nil);
			else
				SetDesaturation(petActionIcon, 1);
			end
			petActionIcon:Show();
			-- Insomniax Custom Texture
			petActionButton:SetNormalTexture("Interface\\AddOns\\Insomniax_BibToolbars\\Images\\Insomniax_Quickslot_Up");
		else
			petActionIcon:Hide();
			-- Insomniax Custom Texture
			--petActionButton:SetNormalTexture("Interface\\AddOns\\Insomniax_BibToolbars\\Images\\Insomniax_Quickslot_Down");
		end
	end
	PetActionBar_UpdateCooldowns();
	if ( not PetHasActionBar() ) then
		--ControlReleased();
		HidePetActionBar();
	end
end

--LedMirage 1.31.2006
--This modified function fixes the "Bottom Left Action Bar" toggle reposition bug
function PetActionBar_UpdatePosition()

	if ( not PetActionBarFrame:IsShown() ) then
		return;
	end
	--PetActionBarFrame:SetPoint("TOPLEFT", "MainMenuBar", "BOTTOMLEFT", PETACTIONBAR_XPOS, PETACTIONBAR_YPOS);
	-- PetActionBarFrame:SetPoint("TOPLEFT", "BibActionBar7", "BOTTOMLEFT", PETACTIONBAR_XPOS, PETACTIONBAR_YPOS);
	PetActionBarFrame:SetPoint("CENTER", "UIParent", "CENTER", -165, 0);
end
--LedMirage 1.31.2006
--This modified function fixes the "Bottom Left Action Bar" toggle reposition bug
function ShapeshiftBar_UpdatePosition()
	-- ShapeshiftBarFrame:SetPoint("BOTTOMLEFT", "MainMenuBar", "TOPLEFT", 30, 0);
	ShapeshiftBarFrame:SetPoint("CENTER", "UIParent", "CENTER", -75, 0);

	for i=1, GetNumShapeshiftForms() do
		getglobal("ShapeshiftButton"..i.."NormalTexture"):SetWidth(64);
		getglobal("ShapeshiftButton"..i.."NormalTexture"):SetHeight(64);
		
	end
end

function ShapeshiftBar_Update()
	local numForms = GetNumShapeshiftForms();
	local fileName, name, isActive, isCastable;
	local button, icon, cooldown;
	local start, duration, enable;

	-- Ascendant 10.07.05 - change 1/1 - if ( numForms > 0 ) then
	if ((numForms > 0) and ((Asc_BibMod_Config.BibClassBarToggle) or (Asc_BibMod_Config.BibClassBarToggle == nil))) then
		ShapeshiftBarFrame:Show();
	else
		ShapeshiftBarFrame:Hide();
	end

	for i=1, NUM_SHAPESHIFT_SLOTS do
		button = getglobal("ShapeshiftButton"..i);
		-- LedMirage 2.07.2006 Test
		button:SetNormalTexture("Interface\\AddOns\\Insomniax_BibToolbars\\Images\\Insomniax_Quickslot_Up");
		getglobal(button:GetName().."NormalTexture"):SetVertexColor(0.85, 0.85, 0.85, 1.0);		

		icon = getglobal("ShapeshiftButton"..i.."Icon");
		if ( i <= numForms ) then
			texture, name, isActive, isCastable = GetShapeshiftFormInfo(i);
			icon:SetTexture(texture);

			--Cooldown stuffs
			cooldown = getglobal("ShapeshiftButton"..i.."Cooldown");
			if ( texture ) then
				cooldown:Show();
			else
				cooldown:Hide();
			end
			start, duration, enable = GetShapeshiftFormCooldown(i);
			CooldownFrame_SetTimer(cooldown, start, duration, enable);

			if ( isActive ) then
				ShapeshiftBarFrame.lastSelected = button:GetID();
				button:SetChecked(1);
			else
				button:SetChecked(0);
			end

			if ( isCastable ) then
				icon:SetVertexColor(1.0, 1.0, 1.0);
			else
				icon:SetVertexColor(0.4, 0.4, 0.4);
			end

			button:Show();
		else
			button:Hide();
		end
	end
end

function ShowPetActionBar()
	if ( PetHasActionBar() and PetActionBarFrame.showgrid == 0 and (PetActionBarFrame.mode ~= "show") and not PetActionBarFrame.locked and not PetActionBarFrame.ctrlPressed ) then
		PetActionBarFrame:Show();
		if ( PetActionBarFrame.completed ) then
			PetActionBarFrame.slideTimer = 0;
		end
		PetActionBarFrame.timeToSlide = PETACTIONBAR_SLIDETIME;
		PetActionBarFrame.yTarget = PETACTIONBAR_YPOS;
		PetActionBarFrame.mode = "show";
	end
end

function HidePetActionBar()
	if ( PetActionBarFrame.showgrid == 0 and PetActionBarFrame:IsVisible() and not PetActionBarFrame.locked and not PetActionBarFrame.ctrlPressed ) then
		if ( PetActionBarFrame.completed ) then
			PetActionBarFrame.slideTimer = 0;
		end
		PetActionBarFrame.timeToSlide = PETACTIONBAR_SLIDETIME;
		PetActionBarFrame.yTarget = PETACTIONBAR_YPOS;
		PetActionBarFrame.mode = "hide";
	end
end

-- LedMirage 12/02/2005
function BibDragButton_OnEnter()
	-- put the tool tip in the default position
	GameTooltip_SetDefaultAnchor(GameTooltip, this);

	GameTooltip:SetText("Insomniax BibToolbars Drag Tab", 255/255, 209/255, 0/255);
	GameTooltip:AddLine("Left-click and drag to move", 1.00, 1.00, 1.00);
	GameTooltip:AddLine("This drag tab allows you to move the", 80/255, 143/255, 148/255);
	GameTooltip:AddLine("element it's attached to anywhere on", 80/255, 143/255, 148/255);
	GameTooltip:AddLine("your screen. Don't try to hide unused", 80/255, 143/255, 148/255);
	GameTooltip:AddLine("empty buttons off-screen, instead use", 80/255, 143/255, 148/255);
	GameTooltip:AddLine("the Grid Mode display toggle or the", 80/255, 143/255, 148/255);
	GameTooltip:AddLine("rotate button to hide them.", 80/255, 143/255, 148/255);
	GameTooltip:Show();
end

-- LedMirage 12/02/2005
function BibRotateButton_OnEnter()
	-- put the tool tip in the default position
	GameTooltip_SetDefaultAnchor(GameTooltip, this);

	GameTooltip:SetText("Insomniax BibToolbars Rotate Button", 255/255, 209/255, 0/255);
	GameTooltip:AddLine("Left-click to change the bar configuration", 1.00, 1.00, 1.00);
	GameTooltip:AddLine("This button allows you to change the button", 80/255, 143/255, 148/255);
	GameTooltip:AddLine("layout of the bar it is attached to by cycling", 80/255, 143/255, 148/255);
	GameTooltip:AddLine("between different configurations including", 80/255, 143/255, 148/255);
	GameTooltip:AddLine("one to hide all the buttons on the bar entirely.", 80/255, 143/255, 148/255);
	GameTooltip:AddLine("It is strongly recommended that unused bars", 80/255, 143/255, 148/255);
	GameTooltip:AddLine("are hidden through the use of this button and", 80/255, 143/255, 148/255);
	GameTooltip:AddLine("NOT by moving empty bars off-screen.", 80/255, 143/255, 148/255);
	GameTooltip:Show();
end

-- The normal version of this function is really complicated, and I'm not sure what it's supposed to 
-- do exactly, but it involves resetting the positions of a lot of frames, which hoses BibMod up something 
-- proper, so I'm overriding it
function UIParent_ManageFramePositions()		--  ***LedMirage 4.01.2006	
end

