local MetaMap_TempData = {};
MetaMap_TempData[MetaKB_dbID] = {};


function MetaMapCVT_CheckData()
	local found = false;
	MetaMap_StatusPrint("MetaMap Imports loaded.", true);
	if(MetaMap_NoteData) then
		MetaMap_InstanceImportButton:Enable();
		MetaMap_StatusPrint("Found Instance data file.", true);
		found = true;
	end
	if(MapNotes_Data) then
		MetaMap_MapNotesImportButton:Enable();
		MetaMap_StatusPrint("Found MapNotes data file.", true);
		found = true;
	end
	if(MyKB_Data) then
		MetaMap_KBImportButton:Enable();
		MetaMap_StatusPrint("Found User KB data file.", true);
		found = true;
	end
	if(WoWKB_Data) then
		MetaMap_WoWKBImportButton:Enable();
		MetaMap_StatusPrint("Found WoWKB data file.", true);
		found = true;
	end
	if(not found) then
		MetaMap_StatusPrint("No data files found.", true);
	end
end

function MetaKB_ZoneNametoID(zoneName)
	for index, zoneTable in MetaKB_ZoneIdentifiers do
		if(zoneName == zoneTable.z) then
			return zoneTable.i;
		end
	end
	return 0;
end

function MetaKB_ZoneIDtoName(zone)
	for index, zoneTable in MetaKB_ZoneIdentifiers do
		if zone == zoneTable.i then
			return zoneTable.z;
		end
	end
	return "";
end

function Import_MetaMapData()
	MetaMapNotes_Data[0] = {};
	for index, data in MetaMap_NoteData[0] do
		MetaMapNotes_Data[0][index] = data;
	end
	MetaMap_StatusPrint("Instance data imported successfully.", true);
end

function Import_MapNotes()
	local newCheck = false;
	for continent=1, 2, 1 do
		for zone, zoneTable in MapNotes_Data[continent] do
			for i, value in MapNotes_Data[continent][zone] do
				local newNote = MapNotes_Data[continent][zone][i];
				newCheck = MetaMapNotes_AddNewNote(continent, zone, newNote.xPos, newNote.yPos, newNote.name, newNote.inf1, newNote.inf2, newNote.creator, newNote.icon, newNote.ncol, newNote.in1c, newNote.in2c)
				if(newCheck) then
					local zoneTable = MapNotes_Lines[continent][zone]
					for i, value in zoneTable do
						if(zoneTable[i].x1 == newNote.xPos and zoneTable[i].y1 == newNote.yPos) then
							MetaMapNotes_ToggleLine(continent, zone, zoneTable[i].x1, zoneTable[i].y1, zoneTable[i].x2, zoneTable[i].y2)
						end
					end
				end
			end
		end
	end
	MetaMap_StatusPrint("MapNotes data successfully imported into MetaMap.", true);
end

function Import_WoWKB()
	for name in WoWKB_Data do
		for zoneName in WoWKB_Data[name] do
			local TempData = nil;
			local continent, zone = MetaMap_NameToZoneID(zoneName, 1);
			MetaMap_TempData[MetaKB_dbID][name] = {};
			MetaMap_TempData[MetaKB_dbID][name][continent] = {};
			MetaMap_TempData[MetaKB_dbID][name][continent][zone] = {};
			local found = string.find(name, "(", 1, true);
			if(found) then
				local newname = string.sub(name, 1, string.find(name, "(", 1, true) -2);
				local info = string.sub(name, string.find(name, "(", 1, true) +1, -2);
				TempData = MetaMap_TempData[MetaKB_dbID][newname][continent][zone];
				TempData["inf1"] = info;
			else
				TempData = MetaMap_TempData[MetaKB_dbID][name][continent][zone];
				TempData["inf1"] = "";
			end
			TempData["inf2"] = "";
			TempData["icon"] = 1;
			TempData[1] = MetaKB_Data[name][zoneName][1];
			TempData[2] = MetaKB_Data[name][zoneName][2];
			TempData[3] = MetaKB_Data[name][zoneName][3];
			TempData[4] = MetaKB_Data[name][zoneName][4];
		end
	end
	for name in MetaMap_TempData[MetaKB_dbID] do
		MetaKB_Data[MetaKB_dbID][name] = MetaMap_TempData[MetaKB_dbID][name];
	end
	MetaMap_TempData = {};
end

function MetaKB_ImportFile(update)
	local dupe = false;
	local unknown = false;
	local totalCount = 0;
	local importCount = 0;
	local dupeCount = 0;
	local unknownCount = 0;
	if(MyKB_Data[MetaKB_dbID]) then
		for import, continentTable in MyKB_Data[MetaKB_dbID] do
			for continent, zoneTable in continentTable do
				for zone in zoneTable do
					totalCount = totalCount +1;
					for name in MetaKB_Data[MetaKB_dbID] do
						if(name == import) then
							dupeCount = dupeCount +1;
							dupe = true;
						end
					end
					if(not dupe) then
						MetaMap_TempData[MetaKB_dbID][import] = {};
						MetaMap_TempData[MetaKB_dbID][import][continent] = {};
						MetaMap_TempData[MetaKB_dbID][import][continent][zone] = {};
						local TempData = MetaMap_TempData[MetaKB_dbID][import][continent][zone];
						local ImportData = MyKB_Data[MetaKB_dbID][import][continent][zone];
						TempData["inf1"] = ImportData.inf1;
						TempData["inf2"] = ImportData.inf2;
						TempData["icon"] = ImportData.icon;
						TempData[1] = ImportData[1];
						TempData[2] = ImportData[2];
						TempData[3] = ImportData[3];
						TempData[4] = ImportData[4];
						importCount = importCount +1;
					end
					dupe = false;
				end
			end
		end
	else
		for import, zoneTable in MyKB_Data do
			for zone in zoneTable do
				totalCount = totalCount +1;
				if(not MetaKB_ZoneIdentifiers[zone]) then
					if(type(zone) ~= "string") then
						unknownCount = unknownCount +1;
						unknown = true;
					end
				end
				for name in MetaKB_Data[MetaKB_dbID] do
					if(name == import) then
						dupeCount = dupeCount +1;
						dupe = true;
					end
				end
				if(not dupe and not unknown) then
					local zoneName = zone;
					if(type(zone) ~= "string") then
						zoneName = MetaKB_ZoneIDtoName(zone);
					end
					local continent, newZone = MetaMap_NameToZoneID(zoneName, 1);
					if(newZone ~= 0) then
						MetaMap_TempData[MetaKB_dbID][import] = {};
						MetaMap_TempData[MetaKB_dbID][import][continent] = {};
						MetaMap_TempData[MetaKB_dbID][import][continent][newZone] = {};
						local TempData = MetaMap_TempData[MetaKB_dbID][import][continent][newZone];
						local ImportData = MyKB_Data[import][zone];
						TempData["inf1"] = ImportData.inf1;
						TempData["inf2"] = ImportData.inf2;
						TempData["icon"] = ImportData.icon;
						TempData[1] = ImportData[1];
						TempData[2] = ImportData[2];
						TempData[3] = ImportData[3];
						TempData[4] = ImportData[4];
						importCount = importCount +1;
					else
						unknownCount = unknownCount +1;
					end
				end
				unknown = false;
				dupe = false;
			end
		end
	end
	for index in MetaMap_TempData[MetaKB_dbID] do
		MetaKB_Data[MetaKB_dbID][index] = MetaMap_TempData[MetaKB_dbID][index];
	end
	MetaMap_TempData = {};
	if(update) then
		MetaMap_StatusPrint("MetaMap KB data updated to new format.", true);
	else
		MetaMap_StatusPrint(format(METAKB_IMPORT_SUCCESSFUL, importCount, totalCount, unknownCount, dupeCount), true);
	end
end

function MetaKB_UpdateDB()
	local update = true;
	MyKB_Data = {};
	MyKB_Data = MetaKB_Data;
	MetaKB_Data = {};
	MetaKB_Data[MetaKB_dbID] = {};
	MetaKB_ImportFile(update);
	MyKB_Data = {};
end

if(GetLocale() == "deDE") then
	MetaKB_ZoneIdentifiers = {
    [1] = {
        ["z"] = "Das Alteracgebirge",
        ["i"] = 1
    },
    [2] = {
        ["z"] = "Das Arathihochland",
        ["i"] = 2,
    },
    [3] = {
        ["z"] = "Ashenvale",
        ["i"] = 3,
    },
    [4] = {
        ["z"] = "Azshara",
        ["i"] = 4,
    },
    [5] = {
        ["z"] = "Das \195\150dland",
        ["i"] = 5,
    },
    [6] = {
        ["z"] = "Die verw\195\188steten Lande",
        ["i"] = 6,
    },
    [7] = {
        ["z"] = "Die brennende Steppe",
        ["i"] = 7,
    },
    [8] = {
        ["z"] = "Darkshore",
        ["i"] = 8,
    },
    [9] = {
        ["z"] = "Darnassus",
        ["i"] = 9,
    },
    [10] = {
        ["z"] = "Der Gebirgspass der Totenwinde",
        ["i"] = 10,
    },
    [11] = {
        ["z"] = "Desolace",
        ["i"] = 11,
    },
    [12] = {
        ["z"] = "Dun Morogh",
        ["i"] = 12,
    },
    [13] = {
        ["z"] = "Durotar",
        ["i"] = 13,
    },
    [14] = {
        ["z"] = "Duskwood",
        ["i"] = 14,
    },
    [15] = {
        ["z"] = "Die Marschen von Dustwallow",
        ["i"] = 15,
    },
    [16] = {
        ["z"] = "Die \195\182stlichen Pestl\195\164nder",
        ["i"] = 16,
    },
    [17] = {
        ["z"] = "Der Wald von Elwynn",
        ["i"] = 17,
    },
    [18] = {
        ["z"] = "Felwood",
        ["i"] = 18,
    },
    [19] = {
        ["z"] = "Feralas",
        ["i"] = 19,
    },
    [20] = {
        ["z"] = "Die Vorgebirge von Hillsbrad",
        ["i"] = 20,
    },
    [21] = {
        ["z"] = "Ironforge",
        ["i"] = 21,
    },
    [22] = {
        ["z"] = "Loch Modan",
        ["i"] = 22,
    },
    [23] = {
        ["z"] = "Moonglade",
        ["i"] = 23,
    },
    [24] = {
        ["z"] = "Mulgore",
        ["i"] = 24,
    },
    [25] = {
        ["z"] = "Orgrimmar",
        ["i"] = 25,
    },
    [26] = {
        ["z"] = "Das Redridgegebirge",
        ["i"] = 26,
    },
    [27] = {
        ["z"] = "Die Sengende Schlucht",
        ["i"] = 27,
    },
    [28] = {
        ["z"] = "Silithus",
        ["i"] = 28,
    },
    [29] = {
        ["z"] = "Der Silberwald",
        ["i"] = 29,
    },
    [30] = {
        ["z"] = "Das Steinkrallengebirge",
        ["i"] = 30,
    },
    [31] = {
        ["z"] = "Stormwind",
        ["i"] = 31,
    },
    [32] = {
        ["z"] = "Stranglethorn",
        ["i"] = 32,
    },
    [33] = {
        ["z"] = "Die S\195\188mpfe des Elends",
        ["i"] = 33,
    },
    [34] = {
        ["z"] = "Tanaris",
        ["i"] = 34,
    },
    [35] = {
        ["z"] = "Teldrassil",
        ["i"] = 35,
    },
    [36] = {
        ["z"] = "Das Brachland",
        ["i"] = 36,
    },
    [37] = {
        ["z"] = "Das Hinterland",
        ["i"] = 37,
    },
    [38] = {
        ["z"] = "Thousand Needles",
        ["i"] = 38,
    },
    [39] = {
        ["z"] = "Thunder Bluff",
        ["i"] = 39,
    },
    [40] = {
        ["z"] = "Tirisfal",
        ["i"] = 40,
    },
    [41] = {
        ["z"] = "Undercity",
        ["i"] = 41,
    },
    [42] = {
        ["z"] = "Der Un'Goro Krater",
        ["i"] = 42,
    },
    [43] = {
        ["z"] = "Die westlichen Pestl\195\164nder",
        ["i"] = 43,
    },
    [44] = {
        ["z"] = "Westfall",
        ["i"] = 44,
    },
    [45] = {
        ["z"] = "Das Sumpfland",
        ["i"] = 45,
    },
    [46] = {
        ["z"] = "Winterspring",
        ["i"] = 46,
    },
-- Instances and other special zones
    [300] = {
        ["z"] = "Die Tiefenbahn",
        ["i"] = 300,
    },
    [301] = {
        ["z"] = "Die Todesminen",
        ["i"] = 301,
    },
    [302] = {
        ["z"] = "Blackfathom-Tiefe",
        ["i"] = 302,
    },
    [303] = {
        ["z"] = "Ragefireabgrund",
        ["i"] = 303,
    },
    [304] = {
        ["z"] = "Die H\195\188gel von Razorfen",
        ["i"] = 304,
    },
    [305] = {
        ["z"] = "Der Kral von Razorfen",
        ["i"] = 305,
    },
    [306] = {
        ["z"] = "Das scharlachrote Kloster",
        ["i"] = 306,
    },
    [307] = {
        ["z"] = "Burg Shadowfang",
        ["i"] = 307,
    },
    [308] = {
        ["z"] = "Die H\195\182hlen des Wehklagens",
        ["i"] = 308,
    },
    [309] = {
        ["z"] = "Die Palisade",
        ["i"] = 309,
    },
    [310] = {
        ["z"] = "Maraudon",
        ["i"] = 310,
    },
    [311] = {
        ["z"] = "Uldaman",
        ["i"] = 311,
    },
    [312] = {
        ["z"] = "Gnomeregan",
        ["i"] = 312,
    },
    [313] = {
        ["z"] = "Zul'Gurub",
        ["i"] = 313,
    },
    [314] = {
        ["z"] = "Stratholme",
        ["i"] = 314,
    },
    [315] = {
        ["z"] = "Scholomance",
        ["i"] = 315,
    },
    [316] = {
        ["z"] = "Zul'Farrak",
        ["i"] = 316,
    },
    [317] = {
        ["z"] = "Der geschmolzene Kern",
        ["i"] = 317,
    },
    [318] = {
        ["z"] = "Der Blackrock",
        ["i"] = 318,
    },
    [319] = {
        ["z"] = "Onyxias Hort",
        ["i"] = 319,
    },
    [320] = {
        ["z"] = "Pechschwingenhort",
        ["i"] = 320,
    },
    [321] = {
        ["z"] = "Blackrocktiefen",
        ["i"] = 321,
    },
    [322] = {
        ["z"] = "D\195\188sterbruch",
        ["i"] = 322,
    },
    [323] = {
        ["z"] = "Der Tempel von Atal'Hakkar",
        ["i"] = 323,
    },
    [324] = {
        ["z"] = "Halle der Blackhand",
        ["i"] = 324,
    },
    [325] = {
        ["z"] = "Arathibecken",
        ["i"] = 325,
    },
    [326] = {
        ["z"] = "Alteractal",
        ["i"] = 326,
    },
    [327] = {
        ["z"] = "Warsongschlucht",
        ["i"] = 327,
    },
    [328] = {
        ["z"] = "Der Tempel von Ahn'Quiraj",
        ["i"] = 328,
    },
    [600] = {
        ["z"] = "Das Arathi Hochland",
        ["i"] = 2,
    },
    [601] = {
        ["z"] = "Gasthaus Zur H\195\182hle des L\195\182wen",
        ["i"] = 17,
    },
    [602] = {
        ["z"] = "Rathaus von Darkshire",
        ["i"] = 14,
    },
    [603] = {
        ["z"] = "Gruft",
        ["i"] = 2,
    },
    [604] = {
        ["z"] = "Gasthaus Lakeshire",
        ["i"] = 26,
    },
    [605] = {
        ["z"] = "Rathaus von Lakeshire",
        ["i"] = 26,
    },
    [606] = {
        ["z"] = "Taverne Zum roten Raben",
        ["i"] = 14,
    },
    [607] = {
        ["z"] = "Schildwachenturm",
        ["i"] = 44,
    },
    [608] = {
        ["z"] = "Anvilmar",
        ["i"] = 12,
    },
    [609] = {
        ["z"] = "Lost Rigger-Bucht",
        ["i"] = 34,
    },
    [610] = {
        ["z"] = "Stormwind-Palisade",
        ["i"] = 56,
    },
    [611] = {
        ["z"] = "Gol'Bolar Steinbruch-Mine",
        ["i"] = 12,
    },
    [612] = {
        ["z"] = "Stormwind City",
        ["i"] = 31,
    },
    [613] = {
        ["z"] = "Stonewrought-Pass",
        ["i"] = 22,
    },
    [614] = {
        ["z"] = "Deepwater-Taverne",
        ["i"] = 45,
    },
    [615] = {
        ["z"] = "Boulderfist-Au\195\159enposten",
        ["i"] = 2,
    },
    [616] = {
        ["z"] = "Mauradon",
        ["i"] = 310,
    },
    [617] = {
        ["z"] = "Brambleblade-Klamm",
        ["i"] = 24,
    },
};
elseif(GetLocale() == "frFR") then
	MetaKB_ZoneIdentifiers = {
    [1] = {
        ["z"] = "Montagnes d\226\128\153Alterac",
        ["i"] = 1,
    },
    [2] = {
        ["z"] = "Hautes-terres d\226\128\153Arathi",
        ["i"] = 2,
    },
    [3] = {
        ["z"] = "Ashenvale",
        ["i"] = 3,
    },
    [4] = {
        ["z"] = "Azshara",
        ["i"] = 4,
    },
    [5] = {
        ["z"] = "Badlands",
        ["i"] = 5,
    },
    [6] = {
        ["z"] = "Blasted Lands",
        ["i"] = 6,
    },
    [7] = {
        ["z"] = "Steppes ardentes",
        ["i"] = 7,
    },
    [8] = {
        ["z"] = "Sombrivage",
        ["i"] = 8,
    },
    [9] = {
        ["z"] = "Darnassus",
        ["i"] = 9,
    },
    [10] = {
        ["z"] = "Col de Deadwind",
        ["i"] = 10,
    },
    [11] = {
        ["z"] = "Desolace",
        ["i"] = 11,
    },
    [12] = {
        ["z"] = "Dun Morogh",
        ["i"] = 12,
    },
    [13] = {
        ["z"] = "Durotar",
        ["i"] = 13,
    },
    [14] = {
        ["z"] = "Bois de la p\195\169nombre",
        ["i"] = 14,
    },
    [15] = {
        ["z"] = "Marais de Dustwallow",
        ["i"] = 15,
    },
    [16] = {
        ["z"] = "Plaguelands de l\226\128\153est",
        ["i"] = 16,
    },
    [17] = {
        ["z"] = "For\195\170t d\226\128\153Elwynn",
        ["i"] = 17,
    },
    [18] = {
        ["z"] = "Gangrebois",
        ["i"] = 18,
    },
    [19] = {
        ["z"] = "Feralas",
        ["i"] = 19,
    },
    [20] = {
        ["z"] = "Contreforts d\226\128\153Hillsbrad",
        ["i"] = 20,
    },
    [21] = {
        ["z"] = "Ironforge",
        ["i"] = 21,
    },
    [22] = {
        ["z"] = "Loch Modan",
        ["i"] = 22,
    },
    [23] = {
        ["z"] = "Reflet-de-Lune",
        ["i"] = 23,
    },
    [24] = {
        ["z"] = "Mulgore",
        ["i"] = 24,
    },
    [25] = {
        ["z"] = "Orgrimmar",
        ["i"] = 25,
    },
    [26] = {
        ["z"] = "Les Carmines",
        ["i"] = 26,
    },
    [27] = {
        ["z"] = "Gorge des Vents br\195\187lants",
        ["i"] = 27,
    },
    [28] = {
        ["z"] = "Silithus",
        ["i"] = 28,
    },
    [29] = {
        ["z"] = "For\195\170t des Pins argent\195\169s",
        ["i"] = 29,
    },
    [30] = {
        ["z"] = "Les Serres-Rocheuses",
        ["i"] = 30,
    },
    [31] = {
        ["z"] = "Cit\195\169 de Stormwind",
        ["i"] = 31,
    },
    [32] = {
        ["z"] = "Vall\195\169e de Stranglethorn",
        ["i"] = 32,
    },
    [33] = {
        ["z"] = "Marais des lamentations",
        ["i"] = 33,
    },
    [34] = {
        ["z"] = "Tanaris",
        ["i"] = 34,
    },
    [35] = {
        ["z"] = "Teldrassil",
        ["i"] = 35,
    },
    [36] = {
        ["z"] = "Les Tarides",
        ["i"] = 36,
    },
    [37] = {
        ["z"] = "Les Hinterlands",
        ["i"] = 37,
    },
    [38] = {
        ["z"] = "Mille pointes",
        ["i"] = 38,
    },
    [39] = {
        ["z"] = "Thunder Bluff",
        ["i"] = 39,
    },
    [40] = {
        ["z"] = "Prairies de Tirisfal",
        ["i"] = 40,
    },
    [41] = {
        ["z"] = "Undercity",
        ["i"] = 41,
    },
    [42] = {
        ["z"] = "Crat\195\168re d\226\128\153Un\226\128\153Goro",
        ["i"] = 42,
    },
    [43] = {
        ["z"] = "Plaguelands de l\226\128\153ouest",
        ["i"] = 43,
    },
    [44] = {
        ["z"] = "Marche de l\226\128\153Ouest",
        ["i"] = 44,
    },
    [45] = {
        ["z"] = "Les Paluns",
        ["i"] = 45,
    },
    [46] = {
        ["z"] = "Winterspring",
        ["i"] = 46,
    },
-- Instances and other special zones
    [300] = {
        ["z"] = "Tram des profondeurs",
        ["i"] = 47,
    },
    [301] = {
        ["z"] = "Les mortemines",
        ["i"] = 48,
    },
    [302] = {
        ["z"] = "Profondeurs de Brassenoire",
        ["i"] = 49,
    },
    [303] = {
        ["z"] = "Gouffre de Ragefeu",
        ["i"] = 50,
    },
    [304] = {
        ["z"] = "Souilles de Tranchebauge",
        ["i"] = 51,
    },
    [305] = {
        ["z"] = "Kraal de Tranchebauge",
        ["i"] = 52,
    },
    [306] = {
        ["z"] = "Monast\195\168re Ecarlate",
        ["i"] = 53,
    },
    [307] = {
        ["z"] = "Donjon d\226\128\153Ombrecroc",
        ["i"] = 54,
    },
    [308] = {
        ["z"] = "Cavernes des lamentations",
        ["i"] = 55,
    },
    [309] = {
        ["z"] = "La Prison",
        ["i"] = 56,
    },
    [310] = {
        ["z"] = "Maraudon",
        ["i"] = 310,
    },
    [311] = {
        ["z"] = "Uldaman",
        ["i"] = 311,
    },
    [312] = {
        ["z"] = "Gnomeregan",
        ["i"] = 312,
    },
    [313] = {
        ["z"] = "Zul\226\128\153Gurub",
        ["i"] = 313,
    },
    [314] = {
        ["z"] = "Stratholme",
        ["i"] = 314,
    },
    [315] = {
        ["z"] = "Scholomance",
        ["i"] = 315,
    },
    [316] = {
        ["z"] = "Zul\226\128\153Farrak",
        ["i"] = 316,
    },
    [317] = {
        ["z"] = "C\197\147ur du Magma",
        ["i"] = 317,
    },
    [318] = {
        ["z"] = "Montagnes Blackrock",
        ["i"] = 318,
    },
    [319] = {
        ["z"] = "Repaire d\226\128\153Onyxia",
        ["i"] = 319,
    },
    [320] = {
        ["z"] = "Repaire de l\226\128\153Aile noire",
        ["i"] = 320,
    },
    [321] = {
        ["z"] = "Profondeurs de Blackrock",
        ["i"] = 321,
    },
    [322] = {
        ["z"] = "Hache-Tripes",
        ["i"] = 322,
    },
    [323] = {
        ["z"] = "Le Temple d\226\128\153Atal\226\128\153Hakkar",
        ["i"] = 323,
    },
    [324] = {
        ["z"] = "Hall des Blackhand",
        ["i"] = 324,
    },
    [325] = {
        ["z"] = "Bassin d\226\128\153Arathi",
        ["i"] = 325,
    },
    [326] = {
        ["z"] = "Vall\195\169e d\226\128\153Alterac",
        ["i"] = 326,
    },
    [327] = {
        ["z"] = "Goulet des Warsong",
        ["i"] = 327,
    },
    [328] = {
        ["z"] = "The Temple Of Ahn'Qiraj",
        ["i"] = 328,
    },
};
elseif(GetLocale() == "esES") then
	MetaKB_ZoneIdentifiers = {
    [1] = {
        ["z"] = "Alterac Mountains",
        ["i"] = 1
    },
    [2] = {
        ["z"] = "Arathi Highlands",
        ["i"] = 2,
    },
    [3] = {
        ["z"] = "Ashenvale",
        ["i"] = 3,
    },
    [4] = {
        ["z"] = "Azshara",
        ["i"] = 4,
    },
    [5] = {
        ["z"] = "Badlands",
        ["i"] = 5,
    },
    [6] = {
        ["z"] = "Blasted Lands",
        ["i"] = 6,
    },
    [7] = {
        ["z"] = "Burning Steppes",
        ["i"] = 7,
    },
    [8] = {
        ["z"] = "Darkshore",
        ["i"] = 8,
    },
    [9] = {
        ["z"] = "Darnassus",
        ["i"] = 9,
    },
    [10] = {
        ["z"] = "Deadwind Pass",
        ["i"] = 10,
    },
    [11] = {
        ["z"] = "Desolace",
        ["i"] = 11,
    },
    [12] = {
        ["z"] = "Dun Morogh",
        ["i"] = 12,
    },
    [13] = {
        ["z"] = "Durotar",
        ["i"] = 13,
    },
    [14] = {
        ["z"] = "Duskwood",
        ["i"] = 14,
    },
    [15] = {
        ["z"] = "Dustwallow Marsh",
        ["i"] = 15,
    },
    [16] = {
        ["z"] = "Eastern Plaguelands",
        ["i"] = 16,
    },
    [17] = {
        ["z"] = "Elwynn Forest",
        ["i"] = 17,
    },
    [18] = {
        ["z"] = "Felwood",
        ["i"] = 18,
    },
    [19] = {
        ["z"] = "Feralas",
        ["i"] = 19,
    },
    [20] = {
        ["z"] = "Hillsbrad Foothills",
        ["i"] = 20,
    },
    [21] = {
        ["z"] = "Ironforge",
        ["i"] = 21,
    },
    [22] = {
        ["z"] = "Loch Modan",
        ["i"] = 22,
    },
    [23] = {
        ["z"] = "Moonglade",
        ["i"] = 23,
    },
    [24] = {
        ["z"] = "Mulgore",
        ["i"] = 24,
    },
    [25] = {
        ["z"] = "Orgrimmar",
        ["i"] = 25,
    },
    [26] = {
        ["z"] = "Redridge Mountains",
        ["i"] = 26,
    },
    [27] = {
        ["z"] = "Searing Gorge",
        ["i"] = 27,
    },
    [28] = {
        ["z"] = "Silithus",
        ["i"] = 28,
    },
    [29] = {
        ["z"] = "Silverpine Forest",
        ["i"] = 29,
    },
    [30] = {
        ["z"] = "Stonetalon Mountains",
        ["i"] = 30,
    },
    [31] = {
        ["z"] = "Stormwind City",
        ["i"] = 31,
    },
    [32] = {
        ["z"] = "Stranglethorn Vale",
        ["i"] = 32,
    },
    [33] = {
        ["z"] = "Swamp of Sorrows",
        ["i"] = 33,
    },
    [34] = {
        ["z"] = "Tanaris",
        ["i"] = 34,
    },
    [35] = {
        ["z"] = "Teldrassil",
        ["i"] = 35,
    },
    [36] = {
        ["z"] = "The Barrens",
        ["i"] = 36,
    },
    [37] = {
        ["z"] = "The Hinterlands",
        ["i"] = 37,
    },
    [38] = {
        ["z"] = "Thousand Needles",
        ["i"] = 38,
    },
    [39] = {
        ["z"] = "Thunder Bluff",
        ["i"] = 39,
    },
    [40] = {
        ["z"] = "Tirisfal Glades",
        ["i"] = 40,
    },
    [41] = {
        ["z"] = "Undercity",
        ["i"] = 41,
    },
    [42] = {
        ["z"] = "Un'Goro Crater",
        ["i"] = 42,
    },
    [43] = {
        ["z"] = "Western Plaguelands",
        ["i"] = 43,
    },
    [44] = {
        ["z"] = "Westfall",
        ["i"] = 44,
    },
    [45] = {
        ["z"] = "Wetlands",
        ["i"] = 45,
    },
    [46] = {
        ["z"] = "Winterspring",
        ["i"] = 46,
    },
-- Instances and other special zones
    [300] = {
        ["z"] = "Deeprun Tram",
        ["i"] = 47,
    },
    [301] = {
        ["z"] = "The Deadmines",
        ["i"] = 48,
    },
    [302] = {
        ["z"] = "Blackfathom Deeps",
        ["i"] = 49,
    },
    [303] = {
        ["z"] = "Ragefire Chasm",
        ["i"] = 50,
    },
    [304] = {
        ["z"] = "Razorfen Downs",
        ["i"] = 51,
    },
    [305] = {
        ["z"] = "Razorfen Kraul",
        ["i"] = 52,
    },
    [306] = {
        ["z"] = "Scarlet Monastery",
        ["i"] = 53,
    },
    [307] = {
        ["z"] = "Shadowfang Keep",
        ["i"] = 54,
    },
    [308] = {
        ["z"] = "The Wailing Caverns",
        ["i"] = 55,
    },
    [309] = {
        ["z"] = "The Stockade",
        ["i"] = 56,
    },
    [310] = {
        ["z"] = "Maraudon",
        ["i"] = 310,
    },
    [311] = {
        ["z"] = "Uldaman",
        ["i"] = 311,
    },
    [312] = {
        ["z"] = "Gnomeregan",
        ["i"] = 312,
    },
    [313] = {
        ["z"] = "Zul'Gurub",
        ["i"] = 313,
    },
    [314] = {
        ["z"] = "Stratholme",
        ["i"] = 314,
    },
    [315] = {
        ["z"] = "Scholomance",
        ["i"] = 315,
    },
    [316] = {
        ["z"] = "Zul'Farrak",
        ["i"] = 316,
    },
    [317] = {
        ["z"] = "The Molten Core",
        ["i"] = 317,
    },
    [318] = {
        ["z"] = "Blackrock Mountain",
        ["i"] = 318,
    },
    [319] = {
        ["z"] = "Onyxia's Lair",
        ["i"] = 319,
    },
    [320] = {
        ["z"] = "Blackwing Lair",
        ["i"] = 320,
    },
    [321] = {
        ["z"] = "Blackrock Depths",
        ["i"] = 321,
    },
    [322] = {
        ["z"] = "Dire Maul",
        ["i"] = 322,
    },
    [323] = {
        ["z"] = "The Temple of Atal'Hakkar",
        ["i"] = 323,
    },
    [324] = {
        ["z"] = "Hall of Blackhand",
        ["i"] = 324,
    },
    [325] = {
        ["z"] = "Arathi Basin",
        ["i"] = 325,
    },
    [326] = {
        ["z"] = "Alterac Valley",
        ["i"] = 326,
    },
    [327] = {
        ["z"] = "Warsong Gulch",
        ["i"] = 327,
    },
    [328] = {
        ["z"] = "The Temple Of Ahn'Qiraj",
        ["i"] = 328,
    },
    [600] = {
        ["z"] = "City of Ironforge",
        ["i"] = 21,
    },
    [601] = {
        ["z"] = "Lion's Pride Inn",
        ["i"] = 17,
    },
    [602] = {
        ["z"] = "Darkshire Town Hall",
        ["i"] = 14,
    },
    [603] = {
        ["z"] = "Crypt",
        ["i"] = 2,
    },
    [604] = {
        ["z"] = "Lakeshire Inn",
        ["i"] = 26,
    },
    [605] = {
        ["z"] = "Lakeshire Town Hall",
        ["i"] = 26,
    },
    [606] = {
        ["z"] = "Scarlet Raven Tavern",
        ["i"] = 14,
    },
    [607] = {
        ["z"] = "Sentinel Tower",
        ["i"] = 44,
    },
    [608] = {
        ["z"] = "Thistlefur Hold",
        ["i"] = 3,
    },
    [609] = {
        ["z"] = "Hillsbrad",
        ["i"] = 20,
    },
    [610] = {
        ["z"] = "Stormwind Stockade",
        ["i"] = 56,
    },
    [611] = {
        ["z"] = "Anvilmar",
        ["i"] = 12,
    },
};
else
	MetaKB_ZoneIdentifiers = {
    [1] = {
        ["z"] = "Alterac Mountains",
        ["i"] = 1
    },
    [2] = {
        ["z"] = "Arathi Highlands",
        ["i"] = 2,
    },
    [3] = {
        ["z"] = "Ashenvale",
        ["i"] = 3,
    },
    [4] = {
        ["z"] = "Azshara",
        ["i"] = 4,
    },
    [5] = {
        ["z"] = "Badlands",
        ["i"] = 5,
    },
    [6] = {
        ["z"] = "Blasted Lands",
        ["i"] = 6,
    },
    [7] = {
        ["z"] = "Burning Steppes",
        ["i"] = 7,
    },
    [8] = {
        ["z"] = "Darkshore",
        ["i"] = 8,
    },
    [9] = {
        ["z"] = "Darnassus",
        ["i"] = 9,
    },
    [10] = {
        ["z"] = "Deadwind Pass",
        ["i"] = 10,
    },
    [11] = {
        ["z"] = "Desolace",
        ["i"] = 11,
    },
    [12] = {
        ["z"] = "Dun Morogh",
        ["i"] = 12,
    },
    [13] = {
        ["z"] = "Durotar",
        ["i"] = 13,
    },
    [14] = {
        ["z"] = "Duskwood",
        ["i"] = 14,
    },
    [15] = {
        ["z"] = "Dustwallow Marsh",
        ["i"] = 15,
    },
    [16] = {
        ["z"] = "Eastern Plaguelands",
        ["i"] = 16,
    },
    [17] = {
        ["z"] = "Elwynn Forest",
        ["i"] = 17,
    },
    [18] = {
        ["z"] = "Felwood",
        ["i"] = 18,
    },
    [19] = {
        ["z"] = "Feralas",
        ["i"] = 19,
    },
    [20] = {
        ["z"] = "Hillsbrad Foothills",
        ["i"] = 20,
    },
    [21] = {
        ["z"] = "Ironforge",
        ["i"] = 21,
    },
    [22] = {
        ["z"] = "Loch Modan",
        ["i"] = 22,
    },
    [23] = {
        ["z"] = "Moonglade",
        ["i"] = 23,
    },
    [24] = {
        ["z"] = "Mulgore",
        ["i"] = 24,
    },
    [25] = {
        ["z"] = "Orgrimmar",
        ["i"] = 25,
    },
    [26] = {
        ["z"] = "Redridge Mountains",
        ["i"] = 26,
    },
    [27] = {
        ["z"] = "Searing Gorge",
        ["i"] = 27,
    },
    [28] = {
        ["z"] = "Silithus",
        ["i"] = 28,
    },
    [29] = {
        ["z"] = "Silverpine Forest",
        ["i"] = 29,
    },
    [30] = {
        ["z"] = "Stonetalon Mountains",
        ["i"] = 30,
    },
    [31] = {
        ["z"] = "Stormwind City",
        ["i"] = 31,
    },
    [32] = {
        ["z"] = "Stranglethorn Vale",
        ["i"] = 32,
    },
    [33] = {
        ["z"] = "Swamp of Sorrows",
        ["i"] = 33,
    },
    [34] = {
        ["z"] = "Tanaris",
        ["i"] = 34,
    },
    [35] = {
        ["z"] = "Teldrassil",
        ["i"] = 35,
    },
    [36] = {
        ["z"] = "The Barrens",
        ["i"] = 36,
    },
    [37] = {
        ["z"] = "The Hinterlands",
        ["i"] = 37,
    },
    [38] = {
        ["z"] = "Thousand Needles",
        ["i"] = 38,
    },
    [39] = {
        ["z"] = "Thunder Bluff",
        ["i"] = 39,
    },
    [40] = {
        ["z"] = "Tirisfal Glades",
        ["i"] = 40,
    },
    [41] = {
        ["z"] = "Undercity",
        ["i"] = 41,
    },
    [42] = {
        ["z"] = "Un'Goro Crater",
        ["i"] = 42,
    },
    [43] = {
        ["z"] = "Western Plaguelands",
        ["i"] = 43,
    },
    [44] = {
        ["z"] = "Westfall",
        ["i"] = 44,
    },
    [45] = {
        ["z"] = "Wetlands",
        ["i"] = 45,
    },
    [46] = {
        ["z"] = "Winterspring",
        ["i"] = 46,
    },
-- Instances and other special zones
    [300] = {
        ["z"] = "Deeprun Tram",
        ["i"] = 47,
    },
    [301] = {
        ["z"] = "The Deadmines",
        ["i"] = 48,
    },
    [302] = {
        ["z"] = "Blackfathom Deeps",
        ["i"] = 49,
    },
    [303] = {
        ["z"] = "Ragefire Chasm",
        ["i"] = 50,
    },
    [304] = {
        ["z"] = "Razorfen Downs",
        ["i"] = 51,
    },
    [305] = {
        ["z"] = "Razorfen Kraul",
        ["i"] = 52,
    },
    [306] = {
        ["z"] = "Scarlet Monastery",
        ["i"] = 53,
    },
    [307] = {
        ["z"] = "Shadowfang Keep",
        ["i"] = 54,
    },
    [308] = {
        ["z"] = "The Wailing Caverns",
        ["i"] = 55,
    },
    [309] = {
        ["z"] = "The Stockades",
        ["i"] = 56,
    },
    [310] = {
        ["z"] = "Maraudon",
        ["i"] = 310,
    },
    [311] = {
        ["z"] = "Uldaman",
        ["i"] = 311,
    },
    [312] = {
        ["z"] = "Gnomeregan",
        ["i"] = 312,
    },
    [313] = {
        ["z"] = "Zul'Gurub",
        ["i"] = 313,
    },
    [314] = {
        ["z"] = "Stratholme",
        ["i"] = 314,
    },
    [315] = {
        ["z"] = "Scholomance",
        ["i"] = 315,
    },
    [316] = {
        ["z"] = "Zul'Farrak",
        ["i"] = 316,
    },
    [317] = {
        ["z"] = "The Molten Core",
        ["i"] = 317,
    },
    [318] = {
        ["z"] = "Blackrock Mountain",
        ["i"] = 318,
    },
    [319] = {
        ["z"] = "Onyxia's Lair",
        ["i"] = 319,
    },
    [320] = {
        ["z"] = "Blackwing Lair",
        ["i"] = 320,
    },
    [321] = {
        ["z"] = "Blackrock Depths",
        ["i"] = 321,
    },
    [322] = {
        ["z"] = "Dire Maul",
        ["i"] = 322,
    },
    [323] = {
        ["z"] = "The Sunken Temple",
        ["i"] = 323,
    },
    [324] = {
        ["z"] = "Hall of Blackhand",
        ["i"] = 324,
    },
    [325] = {
        ["z"] = "Arathi Basin",
        ["i"] = 325,
    },
    [326] = {
        ["z"] = "Alterac Valley",
        ["i"] = 326,
    },
    [327] = {
        ["z"] = "Warsong Gulch",
        ["i"] = 327,
    },
    [328] = {
        ["z"] = "The Temple of Ahn'Qiraj",
        ["i"] = 328,
    },
    [600] = {
        ["z"] = "City of Ironforge",
        ["i"] = 21,
    },
    [601] = {
        ["z"] = "Lion's Pride Inn",
        ["i"] = 17,
    },
    [602] = {
        ["z"] = "Darkshire Town Hall",
        ["i"] = 14,
    },
    [603] = {
        ["z"] = "Crypt",
        ["i"] = 2,
    },
    [604] = {
        ["z"] = "Lakeshire Inn",
        ["i"] = 26,
    },
    [605] = {
        ["z"] = "Lakeshire Town Hall",
        ["i"] = 26,
    },
    [606] = {
        ["z"] = "Scarlet Raven Tavern",
        ["i"] = 14,
    },
    [607] = {
        ["z"] = "Sentinel Tower",
        ["i"] = 44,
    },
    [608] = {
        ["z"] = "Thistlefur Hold",
        ["i"] = 3,
    },
    [609] = {
        ["z"] = "Hillsbrad",
        ["i"] = 20,
    },
    [610] = {
        ["z"] = "Stormwind Stockade",
        ["i"] = 56,
    },
    [611] = {
        ["z"] = "Anvilmar",
        ["i"] = 12,
    },
};
end
