
function MetaMapBLT_OnSelect(lootID, name)
	local info = "";
	if(lootID and lootID ~= "") then
		if(string.find(lootID,"TrashMobs")) then
			name = "Trash Mobs";
		end
		MetaMapBLT_ToggleDR(1);
		local itemName, itemLink, itemQuality, itemLevel, itemType, itemSubType, itemCount, itemEquipLoc, itemTexture, itemColor;
		local iconFrame, nameFrame, extraFrame;
		local text, extra;
		for i = 1, 30, 1 do
			if(MetaMapBLTData[lootID] ~= nil and MetaMapBLTData[lootID][i] ~= nil and MetaMapBLTData[lootID][i][1] ~= 0) then
				itemName, itemLink, itemQuality, itemLevel, itemType, itemSubType, itemCount, itemEquipLoc, itemTexture = GetItemInfo(MetaMapBLTData[lootID][i][1]);
				if(GetItemInfo(MetaMapBLTData[lootID][i][1])) then
					_, _, _, itemColor = GetItemQualityColor(itemQuality);
					text = itemColor..itemName;
				else
					text = MetaMapBLTData[lootID][i][3];
					text = gsub(text, "=q0=", "|cff9d9d9d");
					text = gsub(text, "=q1=", "|cffFFFFFF");
					text = gsub(text, "=q2=", "|cff1eff00");
					text = gsub(text, "=q3=", "|cff0070dd");
					text = gsub(text, "=q4=", "|cff9F3FFF");
					text = gsub(text, "=q5=", "|cffFF8400");
					text = gsub(text, "=q6=", "|cffFF0000");
				end
				
				extra = MetaMapBLTData[lootID][i][4];
				extra = gsub(extra, "=q0=", "|cff9d9d9d");
				extra = gsub(extra, "=q1=", "|cffFFFFFF");
				extra = gsub(extra, "=q2=", "|cff1eff00");
				extra = gsub(extra, "=q3=", "|cff0070dd");
				extra = gsub(extra, "=q4=", "|cff9F3FFF");
				extra = gsub(extra, "=q5=", "|cffFF8400");
				extra = gsub(extra, "=q6=", "|cffFF0000");
				extra = gsub(extra, "=ds=", "|cffFFd200");
				if(not GetItemInfo(MetaMapBLTData[lootID][i][1])) then
					extra = extra.." |cffff0000(no iteminfo)";
				end
			
				getglobal("MetaMapBLTItem_"..i.."_Icon"):SetTexture("Interface\\Icons\\"..MetaMapBLTData[lootID][i][2]);
				getglobal("MetaMapBLTItem_"..i.."_Extra"):SetText(extra);
				getglobal("MetaMapBLTItem_"..i.."_Name"):SetText(text);
				getglobal("MetaMapBLTItem_"..i).itemID = MetaMapBLTData[lootID][i][1];
				getglobal("MetaMapBLTItem_"..i).storeID = MetaMapBLTData[lootID][i][1];
				getglobal("MetaMapBLTItem_"..i).droprate = MetaMapBLTData[lootID][i][5];
				getglobal("MetaMapBLTItem_"..i).i = 1;
				getglobal("MetaMapBLTItem_"..i):Show();
			else
				getglobal("MetaMapBLTItem_"..i):Hide();
			end
		end
	else
		info = "\n\n\n\nNo information available for this item";
		for i = 1, 30, 1 do
			getglobal("MetaMapBLTItem_"..i):Hide();
		end            
	end
	MetaMapBLT_TitleText:SetText(name..info);
	MetaMapBLT_HelpText:SetText("|cff9d9d9dShift+Click: Link Item - CTRL+Click: Dressing Room", 0.25, 0, 0.25);
	MetaMapBLTFrame:Show();
end

function MetaMapBLTItem_OnEnter()
	if(this.itemID ~= nil and GetItemInfo(this.itemID) ~= nil) then
		GameTooltip:SetOwner(this, "ANCHOR_RIGHT", -200, 0);
		GameTooltip:SetHyperlink("item:"..this.itemID..":0:0:0");
		if( this.droprate ~= nil) then
			GameTooltip:AddLine("Drop Rate: "..this.droprate, 1, 1, 0);
		end
		GameTooltip:Show();
	end
end

function MetaMapBLTItem_OnLeave()
	GameTooltip:Hide();
end

function MetaMapBLTItem_OnClick()
	local iteminfo = GetItemInfo(this.itemID);
	local color = strsub(getglobal("MetaMapBLTItem_"..this:GetID().."_Name"):GetText(), 1, 10);
	local name = strsub(getglobal("MetaMapBLTItem_"..this:GetID().."_Name"):GetText(), 11);
	if(ChatFrameEditBox:IsVisible() and IsShiftKeyDown() and iteminfo) then
		ChatFrameEditBox:Insert(color.."|Hitem:"..this.itemID..":0:0:0|h["..name.."]|h|r");
	elseif(IsControlKeyDown() and iteminfo) then
		DressUpFrame:Show();
		DressUpItemLink(this.itemID);
	end
end
    
function MetaMapBLT_ToggleDR(mode)
	if(mode == 1) then
		DressUpFrame:SetMovable(true);
		DressUpFrame:SetFrameStrata("FULLSCREEN");
		DressUpFrame:SetScript("OnMouseDown", X_Frame:GetScript("OnMouseDown"));
		DressUpFrame:SetScript("OnMouseUp", X_Frame:GetScript("OnMouseUp"));
	else
		DressUpFrame:SetMovable(false);
		DressUpFrame:SetFrameStrata("HIGH");
		DressUpFrame:SetScript("OnMouseDown", nil);
		DressUpFrame:SetScript("OnMouseUp", nil);
	end
end