--[[
  ****************************************************************
	Scrolling Combat Text - Damage v1.0

	Author: Grayhoof
	****************************************************************
	Description:

	Thank you to:

	Official Site:
		http://grayhoof.wowinterface.com 
	
	****************************************************************]]
--global name
SCTD = {}

--check SCT version
if ((SCT_Get("VERSION") == "4.12") or (tonumber(SCT_Get("VERSION")) >= 4.12)) then
	SCTD_LoadOptions();
else
	StaticPopupDialogs["SCTD_VERSION"] = {
							  text = SCTD_Version_Warning,
							  button1 = TEXT(OKAY) ,
							  timeout = 0,
							  whileDead = 1,
							  hideOnEscape = 1,
							  showAlert = 1
							};
	StaticPopup_Show("SCTD_VERSION");
	SCTOptionsFrame_Misc103:Hide();
	return;
end

-- local constants
local SCTD_Vars_Loaded = nil;
local Original_SCT_Menu = nil;
local Original_SCT_ShowExample = nil;

--Animation System variables
local SCTD_LASTCRITBAR = 1;	

local arrMsgData = {
		["MSGTEXT1"] = {size=1, xoffset=0, yoffset=0, align="center", height=5},
		["CRITTEXT1"] = {size=1.5, xoffset=-300, yoffset=25, align="right", height=4},
		["CRITTEXT2"] = {size=1.5, xoffset=300, yoffset=25, align="left", height=4}
}

local default_config = {
		["SCTD_VERSION"] = SCTD_Version,
		["SCTD_ENABLED"] = 1,
		["SCTD_SHOWMELEE"] = 1,
		["SCTD_SHOWPERIODIC"] = 1,
		["SCTD_SHOWSPELL"] = 1,
		["SCTD_SHOWPET"] = 1,
		["SCTD_FLAGDMG"] = nil,
		["SCTD_SHOWDMGTYPE"] = nil,
		["SCTD_SHOWSPELLNAME"] = nil,
		["SCTD_SHOWRESIST"] = 1,
		["SCTD_SHOWTARGETS"] = nil,
		["SCTD_MSGXOFFSET"] = 0,
		["SCTD_MSGYOFFSET"] = 250,
		["SCTD_MSGFADE"] = 1.5,
		["SCTD_MSGFONT"] = 2,		-- *** LedMirage 6/02/2006 (1)
		["SCTD_MSGFONTSHADOW"] = 1,
		["SCTD_MSGSIZE"] = 24,
		["SCTD_DMGFONT"] = nil
	};
	
local default_config_colors = {
		["SCTD_SHOWMELEE"] = {r = 1.0, g = 1.0, b = 1.0},
		["SCTD_SHOWPERIODIC"] = {r = 1.0, g =1.0, b = 0.0},
		["SCTD_SHOWSPELL"] = {r = 1.0, g = 1.0, b = 0.0},
		["SCTD_SHOWPET"] = {r = 0.6, g = 0.6, b = 0.0}
}

local arrShadowOutline = {
	[1] = "",
	[2] = "OUTLINE",
	[3] = "THICKOUTLINE"
}

--Create Frame for events
SCTDFrame = CreateFrame("Frame", "SCTD");

--Setup event 
SCTDFrame:SetScript("OnEvent",
		    function() 
		       SCTD:SCTD_OnEvent(event, arg1);
		    end);

--Register main Events
SCTDFrame:RegisterEvent("ADDON_LOADED");
SCTDFrame:RegisterEvent("VARIABLES_LOADED");

----------------------
--Set the global player config
function SCTD:SCTD_Initialize()
		
	--core chat events
	this:RegisterEvent("CHAT_MSG_COMBAT_SELF_HITS");
	this:RegisterEvent("CHAT_MSG_COMBAT_SELF_MISSES");
	this:RegisterEvent("CHAT_MSG_SPELL_SELF_DAMAGE");
	this:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE");
	this:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_HOSTILEPLAYER_DAMAGE");
	this:RegisterEvent("CHAT_MSG_COMBAT_PET_HITS");
	this:RegisterEvent("CHAT_MSG_COMBAT_PET_MISSES");
	this:RegisterEvent("CHAT_MSG_SPELL_PET_DAMAGE");

	-- Add Slash Commands
	SlashCmdList["SCTD"] = self.SCTD_showMenu;
	SLASH_SCTD1 = "/sctd";
	
	-- myAddOns support
	if(myAddOnsList) then
		myAddOnsList.SCTD = {
			name = SCTD_CB_NAME,
			description = SCTD_CB_LONG_DESC,
			version = SCTD_Version,
			frame = "SCTD",
			optionsframe = "SCTDOptions",
			category = MYADDONS_CATEGORY_COMBAT
		};
	end
	
	--Cosmos support
	if ( EarthFeature_AddButton ) then
		EarthFeature_AddButton(
		   {
		      id="SCT";
		      name=SCTD_CB_NAME;
		      text=SCTD_CB_NAME;
		      subtext=SCTD_CB_SHORT_DESC;
		      helptext=SCTD_CB_LONG_DESC;
		      icon=SCTD_CB_ICON;
		      callback=SCTD_showMenu;
		   }
		);
	elseif (Cosmos_RegisterButton) then
		Cosmos_RegisterButton (
		   SCTD_CB_NAME,
		   SCTD_CB_SHORT_DESC,
		   SCTD_CB_LONG_DESC,
		   SCTD_CB_ICON,
		   SCTD_showMenu,
		   function()
		      return true;
		   end
		);
		default_config.ENABLED = 0;
	end
	
	-- Add to CTMod Control panel if available
	if ( CT_RegisterMod ) then
		CT_RegisterMod(SCTD_CB_NAME, nil, 5, SCTD_CB_ICON, SCTD_CB_LONG_DESC, "switch", nil, self.SCTD_showMenu);
	end
	
	--Hook SCT show menu
	Original_SCT_Menu = SCT_showMenu;
	SCT_showMenu = self.SCTD_Menu_Hook;
		
	--Hook SCT ShowExample
	Original_SCT_ShowExample = SCT_ShowExample;
	SCT_ShowExample = self.SCTD_ShowExample_Hook;
				
	--update old values
	self:SCTD_UpdateValues();
	
	--setup msgs
	self:SCTD_MsgInit();

end

----------------------
--Reset everything to default for SCTD
function SCTD:SCTD_Menu_Hook()
	SCTD:SCTD_UpdateValues();
	Original_SCT_Menu();
	--if window is showing, reload it
	if (SCTDOptions:IsVisible()) then
		SCTDOptions:Hide();
		SCTDOptions:Show();
	end
end

---------------------
--Show SCT Example
function SCTD:SCTD_ShowExample_Hook()
	Original_SCT_ShowExample();
	
	SCTD:SCTD_MsgInit();
	--show msg frame
	SCTD_EXAMPLEMSG:Show();
	--get object
	example = getglobal("SCTDMsgExample1");
	--set outline
	local outline = arrShadowOutline[SCT_Get("SCTD_MSGFONTSHADOW")]
	--set font
	example:SetFont(SCT_FONTS[SCT_Get("SCTD_MSGFONT")].path, SCT_Get("SCTD_MSGSIZE"), outline);
	--set the color
	example:SetTextColor(1, 1, 1);
	--set alpha
	example:SetAlpha(1);
	--Position
	example:SetPoint("CENTER", "UIParent", "CENTER", SCT_Get("SCTD_MSGXOFFSET"), SCT_Get("SCTD_MSGYOFFSET")-50);
	--Set the text to display
	example:SetText(SCTD_EXAMPLE);
end

----------------------
--Update old values for new versions
function SCTD:SCTD_UpdateValues()
	local i, var;
	-- non check boxes
	local new_vars = {
		"SCTD_VERSION",
		"SCTD_MSGXOFFSET",
		"SCTD_MSGYOFFSET",
		"SCTD_MSGFADE",
		"SCTD_MSGFONT",
		"SCTD_MSGFONTSHADOW",
		"SCTD_MSGSIZE"
	}
	
	--Version specfic updates first
	if (SCT_Get("SCTD_VERSION") ~= SCTD_Version) then
		--first load, get them all
		if (not SCT_Get("SCTD_VERSION")) then
			for i in default_config do
				SCT_Set(i, default_config[i]);
			end
			for i in default_config_colors do
				SCT_SetTable(SCT_COLORS_TABLE, i, default_config_colors[i]);
			end
		end
		--load for new vars only
		if (SCT_Get("SCTD_VERSION") == "v1.0") then
			--nothing for now, next update
		end
		SCT_Set("SCTD_VERSION", SCTD_Version);
	end
	
	--more checking since I'm using SCT's config table's
	
	--set mandatory defaults, just incase old version
	for _, i in new_vars do
		var = SCT_Get(i) or default_config[i];
		SCT_Set(i, var);
	end
	
	--set mandatory colors, just incase very old version
	for i in default_config_colors do
		var = SCT_GetTable(SCT_COLORS_TABLE, i) or default_config_colors[i];
		SCT_SetTable(SCT_COLORS_TABLE, i, var);
	end
	
	--cleanup
	local new_vars = nil;
	local i, var = nil
end

----------------------
-- Event Handler
-- this function parses events that are printed in the combat
-- chat window then displays the changes
function SCTD:SCTD_OnEvent()
				
	--Player loaded completely
	if (event == "ADDON_LOADED") then
		if (strlower(arg1) == "sctd") then
			SCTD_Vars_Loaded = 1;
			self:SCTD_Initialize();
		end
	
	--Vars loaded, only load once (bug fix for some users)
	elseif (event == "VARIABLES_LOADED") then
		if (not SCTD_Vars_Loaded) then
			SCTD_Vars_Loaded = 1;
			self:SCTD_Initialize();
		end
		
	-- if its enabled
	elseif (SCT_Get("SCTD_ENABLED")) then
		--All other combat events	
		if (arg1) then
			self:SCTD_ParseCombat(event, arg1);	
		end
	end
end

----------------------
-- Parses all combat events using global strings
-- Partly taken from NurfedUI Combatlog http://www.nurfedui.net/addons.php
function SCTD:SCTD_ParseCombat(event, arg1)
	local target, spell, damage, damagetype, pet;
	
	--Player Hits, melee
	if (event == "CHAT_MSG_COMBAT_SELF_HITS") then
		
		target, damage = SCTGlobalParser_ParseMessage(arg1, COMBATHITCRITSELFOTHER) 
		if target then
			self:SCTD_Display("SCTD_SHOWMELEE", damage, 1, nil, nil, target);
			return;
		end
		target, damage = SCTGlobalParser_ParseMessage(arg1, COMBATHITSELFOTHER) 
		if target then
			self:SCTD_Display("SCTD_SHOWMELEE", damage, nil, nil, nil, target);
			return;
		end

	--Miss events Melee
	elseif (event == "CHAT_MSG_COMBAT_SELF_MISSES") then
		
		--non-hits
		target = SCTGlobalParser_ParseMessage(arg1, MISSEDSELFOTHER)
		if target then
			self:SCTD_Display("SCTD_SHOWMELEE", MISS, nil, nil, nil, target);
			return;
		end
		target = SCTGlobalParser_ParseMessage(arg1, VSPARRYSELFOTHER)
		if target then
			self:SCTD_Display("SCTD_SHOWMELEE", PARRY, nil, nil, nil, target);
			return;
		end
		target = SCTGlobalParser_ParseMessage(arg1, VSDODGESELFOTHER)
		if target then
			self:SCTD_Display("SCTD_SHOWMELEE", DODGE, nil, nil, nil, target);
			return;
		end
		target = SCTGlobalParser_ParseMessage(arg1, VSBLOCKSELFOTHER)
		if target then
			self:SCTD_Display("SCTD_SHOWMELEE", BLOCK, nil, nil, nil, target);
			return;
		end
	  target = SCTGlobalParser_ParseMessage(arg1, VSABSORBSELFOTHER)
	  if target then
			self:SCTD_Display("SCTD_SHOWMELEE", ABSORB, nil, nil, nil, target);
			return;
		end
		target = SCTGlobalParser_ParseMessage(arg1, VSEVADESELFOTHER)
	  if target then
			self:SCTD_Display("SCTD_SHOWMELEE", EVADE, nil, nil, nil, target);
			return;
		end
		target = SCTGlobalParser_ParseMessage(arg1, IMMUNESELFOTHER)
	  if target then
			self:SCTD_Display("SCTD_SHOWMELEE", IMMUNE, nil, nil, nil, target);
			return;
		end
		target = SCTGlobalParser_ParseMessage(arg1, VSIMMUNESELFOTHER)
	  if target then
			self:SCTD_Display("SCTD_SHOWMELEE", IMMUNE, nil, nil, nil, target);
			return;
		end

	--Player Hits, spell
	elseif (event == "CHAT_MSG_SPELL_SELF_DAMAGE") then
		
		spell, target, damage, damagetype = SCTGlobalParser_ParseMessage(arg1, SPELLLOGCRITSCHOOLSELFOTHER) 
		if spell then
			self:SCTD_Display("SCTD_SHOWSPELL", damage, 1, damagetype, SCT_FindResists(), target, spell);
			return;
		end
		spell, target, damage = SCTGlobalParser_ParseMessage(arg1, SPELLLOGCRITSELFOTHER) 
		if spell then
			self:SCTD_Display("SCTD_SHOWSPELL", damage, 1, nil, nil, target, spell);
			return;
		end
		spell, target, damage, damagetype = SCTGlobalParser_ParseMessage(arg1, SPELLLOGSCHOOLSELFOTHER) 
		if spell then
			self:SCTD_Display("SCTD_SHOWSPELL", damage, nil, damagetype, SCT_FindResists(), target, spell);
			return;
		end
		spell, target, damage = SCTGlobalParser_ParseMessage(arg1, SPELLLOGSELFOTHER) 
		if spell then
			self:SCTD_Display("SCTD_SHOWSPELL", damage, nil, nil, nil, target, spell);
			return;
		end
		
		--non-hits
		spell, target = SCTGlobalParser_ParseMessage(arg1, SPELLRESISTSELFOTHER)
		if spell then
			self:SCTD_Display("SCTD_SHOWSPELL", RESIST, nil, nil, nil, target, spell);
			return;
		end
		spell, target  = SCTGlobalParser_ParseMessage(arg1, SPELLMISSSELFOTHER)
		if spell then
			self:SCTD_Display("SCTD_SHOWSPELL", MISS, nil, nil, nil, target, spell);
			return;
		end
		spell, target = SCTGlobalParser_ParseMessage(arg1, SPELLDEFLECTEDSELFOTHER)
		if spell then
			self:SCTD_Display("SCTD_SHOWSPELL", DEFLECT, nil, nil, nil, target, spell);
			return;
		end
		spell, target = SCTGlobalParser_ParseMessage(arg1, SPELLDODGEDSELFOTHER)
		if spell then
			self:SCTD_Display("SCTD_SHOWSPELL", DODGE, nil, nil, nil, target, spell);
			return;
		end
		spell, target = SCTGlobalParser_ParseMessage(arg1, SPELLBLOCKEDSELFOTHER)
		if spell then
			self:SCTD_Display("SCTD_SHOWSPELL", BLOCK, nil, nil, nil, target, spell);
			return;
		end
		spell, target = SCTGlobalParser_ParseMessage(arg1, SPELLLOGABSORBSELFOTHER)
	  if spell then
			self:SCTD_Display("SCTD_SHOWSPELL", ABSORB, nil, nil, nil, target, spell);
			return;
		end
		spell, target = SCTGlobalParser_ParseMessage(arg1, SPELLEVADEDSELFOTHER)
	  if spell then
			self:SCTD_Display("SCTD_SHOWSPELL", EVADE, nil, nil, nil, target, spell);
			return;
		end
		target, spell = SCTGlobalParser_ParseMessage(arg1, IMMUNESPELLSELFOTHER)
	  if target then
			self:SCTD_Display("SCTD_SHOWSPELL", IMMUNE, nil, nil, nil, target, spell);
			return;
		end
		spell, target = SCTGlobalParser_ParseMessage(arg1, SPELLIMMUNESELFOTHER)
	  if spell then
			self:SCTD_Display("SCTD_SHOWSPELL", IMMUNE, nil, nil, nil, target, spell);
			return;
		end
		spell, target = SCTGlobalParser_ParseMessage(arg1, SPELLREFLECTSELFOTHER)
	  if spell then
			self:SCTD_Display("SCTD_SHOWSPELL", REFLECT, nil, nil, nil, target, spell);
			return;
		end
						
	--Over Time Events
	elseif (event == "CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE" or
					event == "CHAT_MSG_SPELL_PERIODIC_HOSTILEPLAYER_DAMAGE") then
	
		target, damage, damagetype, spell = SCTGlobalParser_ParseMessage(arg1, PERIODICAURADAMAGESELFOTHER)
		if target then
			self:SCTD_Display("SCTD_SHOWPERIODIC", damage, nil, damagetype, SCT_FindResists(), target, spell);
			return;
		end
		
	--Per Melee
	elseif (event == "CHAT_MSG_COMBAT_PET_HITS") then
		
		pet, target, damage = SCTGlobalParser_ParseMessage(arg1, COMBATHITCRITOTHEROTHER) 
		if pet then
			self:SCTD_Display("SCTD_SHOWPET", damage, 1, nil, nil, target);
			return;
		end
		pet, target, damage = SCTGlobalParser_ParseMessage(arg1, COMBATHITOTHEROTHER) 
		if pet then
			self:SCTD_Display("SCTD_SHOWPET", damage, nil, nil, nil, target);
			return;
		end
		
	--Pet Miss events Melee
	elseif (event == "CHAT_MSG_COMBAT_PET_MISSES") then
		
		--non-hits
		pet, target = SCTGlobalParser_ParseMessage(arg1, MISSEDOTHEROTHER)
		if pet then
			self:SCTD_Display("SCTD_SHOWPET", MISS, nil, nil, nil, target);
			return;
		end
		pet, target = SCTGlobalParser_ParseMessage(arg1, VSPARRYOTHEROTHER)
		if pet then
			self:SCTD_Display("SCTD_SHOWPET", PARRY, nil, nil, nil, target);
			return;
		end
		pet, target = SCTGlobalParser_ParseMessage(arg1, VSDODGEOTHEROTHER)
		if pet then
			self:SCTD_Display("SCTD_SHOWPET", DODGE, nil, nil, nil, target);
			return;
		end
		pet, target = SCTGlobalParser_ParseMessage(arg1, VSBLOCKOTHEROTHER)
		if pet then
			self:SCTD_Display("SCTD_SHOWPET", BLOCK, nil, nil, nil, target);
			return;
		end
		pet, target = SCTGlobalParser_ParseMessage(arg1, VSABSORBOTHEROTHER)
	  if pet then
			self:SCTD_Display("SCTD_SHOWPET", ABSORB, nil, nil, nil, target);
			return;
		end
		pet, target = SCTGlobalParser_ParseMessage(arg1, VSEVADEOTHEROTHER)
	  if pet then
			self:SCTD_Display("SCTD_SHOWPET", EVADE, nil, nil, nil, target);
			return;
		end
		pet, target = SCTGlobalParser_ParseMessage(arg1, IMMUNEOTHEROTHER)
	  if pet then
			self:SCTD_Display("SCTD_SHOWPET", IMMUNE, nil, nil, nil, target);
			return;
		end
		pet, target = SCTGlobalParser_ParseMessage(arg1, VSIMMUNEOTHEROTHER)
	  if pet then
			self:SCTD_Display("SCTD_SHOWPET", IMMUNE, nil, nil, nil, target);
			return;
		end
		
	--Pet Hits, spell
	elseif (event == "CHAT_MSG_SPELL_PET_DAMAGE") then
		
		pet, spell, target, damage, damagetype = SCTGlobalParser_ParseMessage(arg1, SPELLLOGCRITSCHOOLOTHEROTHER) 
		if pet then
			self:SCTD_Display("SCTD_SHOWPET", damage, 1, damagetype, SCT_FindResists(), target, spell);
			return;
		end
		pet, spell, target, damage = SCTGlobalParser_ParseMessage(arg1, SPELLLOGCRITOTHEROTHER) 
		if pet then
			self:SCTD_Display("SCTD_SHOWPET", damage, 1, nil, nil, target, spell);
			return;
		end
		pet, spell, target, damage, damagetype = SCTGlobalParser_ParseMessage(arg1, SPELLLOGSCHOOLOTHEROTHER) 
		if pet then
			self:SCTD_Display("SCTD_SHOWPET", damage, nil, damagetype, SCT_FindResists(), target, spell);
			return;
		end
		pet, spell, target, damage = SCTGlobalParser_ParseMessage(arg1, SPELLLOGOTHEROTHER) 
		if pet then
			self:SCTD_Display("SCTD_SHOWPET", damage, nil, nil, nil, target, spell);
			return;
		end
		
		--non-hits
		pet, spell, target = SCTGlobalParser_ParseMessage(arg1, SPELLRESISTOTHEROTHER)
		if pet then
			self:SCTD_Display("SCTD_SHOWPET", RESIST, nil, nil, nil, target, spell);
			return;
		end
		pet, spell, target  = SCTGlobalParser_ParseMessage(arg1, SPELLMISSOTHEROTHER)
		if pet then
			self:SCTD_Display("SCTD_SHOWPET", MISS, nil, nil, nil, target, spell);
			return;
		end
		pet, spell, target = SCTGlobalParser_ParseMessage(arg1, SPELLDEFLECTEDOTHEROTHER)
		if pet then
			self:SCTD_Display("SCTD_SHOWPET", DEFLECT, nil, nil, nil, target, spell);
			return;
		end
		pet, spell, target = SCTGlobalParser_ParseMessage(arg1, SPELLDODGEDOTHEROTHER)
		if pet then
			self:SCTD_Display("SCTD_SHOWPET", DODGE, nil, nil, nil, target, spell);
			return;
		end
		pet, spell, target = SCTGlobalParser_ParseMessage(arg1, SPELLBLOCKEDOTHEROTHER)
		if pet then
			self:SCTD_Display("SCTD_SHOWPET", BLOCK, nil, nil, nil, target, spell);
			return;
		end
		pet, spell, target = SCTGlobalParser_ParseMessage(arg1, SPELLLOGABSORBOTHEROTHER)
	  if pet then
			self:SCTD_Display("SCTD_SHOWPET", ABSORB, nil, nil, nil, target, spell);
			return;
		end
		pet, spell, target = SCTGlobalParser_ParseMessage(arg1, SPELLEVADEDOTHEROTHER)
	  if pet then
			self:SCTD_Display("SCTD_SHOWPET", EVADE, nil, nil, nil, target, spell);
			return;
		end
		target, pet, spell = SCTGlobalParser_ParseMessage(arg1, IMMUNESPELLOTHEROTHER)
	  if target then
			self:SCTD_Display("SCTD_SHOWPET", IMMUNE, nil, nil, nil, target, spell);
			return;
		end
		pet, spell, target = SCTGlobalParser_ParseMessage(arg1, SPELLIMMUNEOTHEROTHER)
	  if pet then
			self:SCTD_Display("SCTD_SHOWPET", IMMUNE, nil, nil, nil, target, spell);
			return;
		end
		pet, spell, target = SCTGlobalParser_ParseMessage(arg1, SPELLREFLECTOTHEROTHER)
	  if pet then
			self:SCTD_Display("SCTD_SHOWPET", REFLECT, nil, nil, nil, target, spell);
			return;
		end
			
	end
end


----------------------
--Display for mainly combat events
--Mainly used for short messages
function SCTD:SCTD_Display(option, msg1, crit, damagetype, resisted, target, spell)
	local rbgcolor, showcrit, showmsg, adat;
	
	--if option is on
	if (SCT_Get(option)) then
		--get options
		rbgcolor = SCT_GetTable(SCT_COLORS_TABLE, option);

		--if damage type
		if ((damagetype) and (SCT_Get("SCTD_SHOWDMGTYPE"))) then
			msg1 = msg1.." "..damagetype.."";
		end
		--if resisted
		if ((resisted) and (SCT_Get("SCTD_SHOWRESIST"))) then
			msg1 = msg1.." {"..resisted.."}";
		end
		--if target label
		if ((target) and (SCT_Get("SCTD_SHOWTARGETS"))) then
			msg1 = target..": "..msg1;
		end
		--if spell 
		if ((spell) and (SCT_Get("SCTD_SHOWSPELLNAME"))) then
			msg1 = msg1.." ("..spell..")";
		end
		--if flag
		if (SCT_Get("SCTD_FLAGDMG")) then
			msg1 = SCTD_SelfFlag..msg1..SCTD_SelfFlag;
		end
		
		if (crit) then
			self:SCTD_Display_Crit_Damage( msg1, rbgcolor );
		else
			self:SCTD_Display_Damage( msg1, rbgcolor );
		end

	end
end


----------------------
--Displays a message at the top of the screen
function SCTD:SCTD_Display_Damage(msg, color)
		SCTD_MSGTEXT1:SetPoint("CENTER", "UIParent", "CENTER", SCT_Get("SCTD_MSGXOFFSET"), SCT_Get("SCTD_MSGYOFFSET"));
		SCTD_MSGTEXT1:AddMessage(msg, color.r, color.g, color.b, 1, SCT_Get("SCTD_MSGFADE"));
end

----------------------
--Displays a message at the top of the screen
function SCTD:SCTD_Display_Crit_Damage(msg, color)
		local msgobj = arrMsgData["CRITTEXT"..SCTD_LASTCRITBAR];
		msgobj.FObject:SetPoint("CENTER", "UIParent", "CENTER", SCT_Get("SCTD_MSGXOFFSET") + msgobj.xoffset, SCT_Get("SCTD_MSGYOFFSET") + msgobj.yoffset);
		msgobj.FObject:AddMessage(msg, color.r, color.g, color.b, 1, SCT_Get("SCTD_MSGFADE"));
		--update current text being used
		SCTD_LASTCRITBAR = SCTD_LASTCRITBAR + 1;
		--if we reached the end, set to first
		if (SCTD_LASTCRITBAR >= 3) then
			SCTD_LASTCRITBAR = 1;
		end
end

------------------------
--Setup msg arrays
function SCTD:SCTD_MsgInit()
	for key, value in arrMsgData do
		value.FObject = getglobal("SCTD_"..key);
		self:SCTD_SetMsgFont(value.FObject, value.size, value.height, value.align);
	end
	--set WoW Damage Flags
	if (SCT_Get("SCTD_DMGFONT")) then
		SetCVar("CombatDamage", 0);
		SetCVar("CombatLogPeriodicSpells", 1);
		SetCVar("PetMeleeDamage", 1);
	else
		SetCVar("CombatDamage", 1);
	end
end

-------------------------
--Set the font of an object using msg vars
function SCTD:SCTD_SetMsgFont(object, size, height, align)
	local outline;

	--set outline
	outline = arrShadowOutline[SCT_Get("SCTD_MSGFONTSHADOW")]
	
	--set font
	object:SetFont(SCT_FONTS[SCT_Get("SCTD_MSGFONT")].path, SCT_Get("SCTD_MSGSIZE") * size, outline);
	
	--reset size to allow 3 messages
	object:SetHeight(SCT_Get("SCTD_MSGSIZE") * height * size) 
	
	--set alignment
	object:SetJustifyH(align);
end

----------------------
-- Show the Option Menu
function SCTD:SCTD_showMenu()
	PlaySound("igMainMenuOpen");
	SCTDOptions:Show();
end

----------------------
--Hide the Option Menu
function SCTD:SCTD_hideMenu()
	PlaySound("igMainMenuClose");
	SCTDOptions:Hide();
	SCTD_EXAMPLEMSG:Hide();
	-- myAddOns support
	if(MYADDONS_ACTIVE_OPTIONSFRAME == SCTDOptions) then
		ShowUIPanel(myAddOnsFrame);
	end
end